"""
__channelV2.py_____________________________________________________

Automatically generated AToM3 syntactic object (DO NOT MODIFY DIRECTLY)
Author: yentl
Modified: Wed Dec  5 17:58:51 2012
___________________________________________________________________
"""
from ASGNode import *

from ATOM3Type import *

from graph_channelV2 import *
class channelV2(ASGNode, ATOM3Type):

   def __init__(self, parent = None):
      ASGNode.__init__(self)
      ATOM3Type.__init__(self)
      self.graphClass_ = graph_channelV2
      self.isGraphObjectVisual = True
      if(hasattr(self, '_setHierarchicalLink')):
        self._setHierarchicalLink(False)
      if(hasattr(self, '_setHierarchicalNode')):
        self._setHierarchicalNode(False)
      self.parent = parent
      self.generatedAttributes = {      }
      self.realOrder = []
      self.directEditing = []
   def clone(self):
      cloneObject = channelV2( self.parent )
      for atr in self.realOrder:
         cloneObject.setAttrValue(atr, self.getAttrValue(atr).clone() )
      ASGNode.cloneActions(self, cloneObject)

      return cloneObject
   def copy(self, other):
      ATOM3Type.copy(self, other)
      for atr in self.realOrder:
         self.setAttrValue(atr, other.getAttrValue(atr) )
      ASGNode.copy(self, other)

   def preCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.preCondition(actionID, params)
      else: return None
   def postCondition (self, actionID, * params):
      if self.graphObject_:
         return self.graphObject_.postCondition(actionID, params)
      else: return None
   def preAction (self, actionID, * params):
      if actionID == self.DELETE or actionID == self.DISCONNECT:
         self.disconnect(params)
      if self.graphObject_:
         return self.graphObject_.preAction(actionID, params)
      else: return None
   def postAction (self, actionID, * params):
      if actionID == self.CONNECT:
         self.connect(params)
      if self.graphObject_:
         return self.graphObject_.postAction(actionID, params)
      else: return None
   def connect(self, params):
      # connect
      
      import DEVS_StateChart
      self.SC = DEVS_StateChart.DEVS_StateChart()
      self.SC.initModel( TkInstance=self.parent.parent )
      self.SC.event("connectChannel",self)
      self.SC.event("isChannel")
      
      # Keep a reference to the children
      parentList = self.in_connections_ + self.out_connections_
      for parent in parentList: 
          parent.addChildren( [self] )    
      
      
      self.checkValidity( self )
      
      

   def disconnect(self, params):
      # disconnect
      
      self.SC.event("disconnect")
      
      

   def checkValidity(self, params):
      # checkValidity
      
      obj = self.graphObject_
      if( not obj or not obj.dc ): return
      
      inc = self.in_connections_
      out = self.out_connections_
      
      # There should only be one in-connection, one out-connection
      if( len( inc ) != 1 or len( out ) != 1 ): return
      inc = inc[0]
      out = out[0]
      # Make sure they each have parent (they should!)
      if( not inc.__dict__.has_key( 'devParent' ) ): return
      if( not out.__dict__.has_key( 'devParent' ) ): return
      
      isError = False
      
      # Parent of two ports linked by a channel should NOT be the same
      if( inc.devParent == out.devParent ): isError = True
      
      # The two ports linked by the channel should not both be Outputs
      # Comment out by Bill Song 07/11/2005, because in coupled model, ports at 
      # both ends of a channel can be Outputs
      #if( inc.portType.getValue()[1] != 0 
      #    and out.portType.getValue()[1] != 0 ): isError = True
      
      # Colorize the arrow segments
      segList = obj.in_connections_ + obj.out_connections_
      if( isError ):
          for seg in segList:
              obj.dc.itemconfigure( seg[0], fill='orangered', 
                                      stipple='gray75', width = 4 )
      else:
          for seg in segList:
              obj.dc.itemconfigure( seg[0], fill='black', stipple='', width=2 )
      
      



