#Interfaces between Devs Simulator and Devs Plotter
#Hongyan Song
#August 1st, 2005


class DevsEventSource(object):
  def addEventListener(self, listener):
    pass
    
  def romoveEventListener(self, listener):
    pass
  
  def newEvent(self):
    pass

        
class DevsEventListener(object):
  def newEvent(self, devsEvent):
    pass
  
  def setEventSource(self, eventSource):
    pass

class DevsEvent(object):
  def __init__(self, source='model1', content='Event', time=0.0):
    self.source  = source       #where the event comes from
    self.content = content      #the content of the event
    self.time    = time         #the time when the evetn occurs
    
  def __str__(self):
    return '\nDEVS Event: %s %s %s' % (self.source, self.content, str(self.time)) 
    
    
class DevsEventHandler(object):
  def __init__(self):
    self.listeners = []
    
  def addEventListener(self, listener):
    self.listeners.append(listener)
  
  def removeEventListener(self, listener):
    self.listeners.remove(listener)

    
  def fireNewEvent(self, evt):
    for dl in self.listeners:
      dl.newEvent(evt)
      
#from Tkinter import *

#class CharacterDisplayCanvas(Frame, CharacterListener):

#  def __init__(self, parent=None, color='brown'):
#    Frame.__init__(self, parent)
#    self.pack(expand=YES, fill=BOTH)
#    self.canvas = Canvas(self, bg=color, relief=SUNKEN)
#    self.canvas.config(width=100, height=100)
#    self.canvas.pack()
#    self.tmpChar = None
#    self.txtArea = self.canvas.create_text(10, 10, text=str(self.tmpChar), fill='beige')
    
#  def setCharacterSource(self, characterSource):
#    characterSource.addCharacterListener(self)
      
#  # Need to be modified to add synchronization
#  def newCharacter(self, characterEvent):
#    print 'display canvas received: ', characterEvent.character
#    self.tmpChar = characterEvent.character
#    self.canvas.itemconfigure(self.txtArea, text = str(self.tmpChar))
#    #self.canvas.create_text(10, 10, text=str(self.tmpChar), fill='beige')
    
#from random import *
#import time

#class RandomCharacterGenerator(Thread, CharacterSource):
#  chars = 'abcdefghijklmnopqrstuvwxyz0123456789'

#  def __init__(self):    
#    self.random = Random()
#    self.handler = CharacterEventHandler()
#    Thread.__init__(self)
    
#  def getPauseTime(self):
#    return 2 #max(1000, 5000*self.random.random())
    
#  def addCharacterListener(self, charListener):
#    self.handler.addCharacterListener(charListener)
    
#  def removeCharacterListener(self, charListener):
#    self.handler.removeCharacterListener(charListener)
  
#  def nextCharacter(self):
#    ch = RandomCharacterGenerator.chars[randint(0,len(RandomCharacterGenerator.chars)-1)]
#    print 'next character is: ', ch
#    self.handler.fireNewCharacter(self, ch)
  
#  def run(self):
    
#    global done
#    while( not done ):
#      self.nextCharacter()
#      print self.getPauseTime()
#      time.sleep(self.getPauseTime())
#      #chlock.acquire()
#      #stop=done
#      #chlock.release()
      
#import sys
#class SwingTypeTester(Frame, CharacterSource):
  
#  def __init__(self, parent=None):
#    Frame.__init__(self, parent)
#    self.parent=parent
#    self.pack()
#    self.toolbar = Frame(self.parent, cursor='hand2', relief=SUNKEN, bd=2)
#    self.toolbar.pack(side=BOTTOM, fill=X)       
    
#    self.handler = CharacterEventHandler()
#    self.displayCanvas = CharacterDisplayCanvas(self.parent)
#    self.displayCanvas.pack(side=LEFT)
#    self.feedbackCanvas = CharacterDisplayCanvas(self.parent)
#    self.feedbackCanvas.pack(side=LEFT)
#    self.feedbackCanvas.setCharacterSource(self)
#    self.feedbackCanvas.canvas.bind('<KeyPress>', self.newCharacter)
    
#    self.startButton = Button(self.toolbar, text='Start', command=self.startProducing)
#    self.startButton.pack(side=LEFT)    
#    self.quitButton = Button(self.toolbar, text='Quit', command=self.finished)
#    self.quitButton.pack(side=RIGHT)
#    #print 'state', self.feedbackCanvas.state
#    self.feedbackCanvas.takefocus=1
    
#  def newCharacter(self, event):
#    print 'new character: ', event.char
#    self.handler.fireNewCharacter(self, event.char)
  
#  def finished(self):
#    chlock.acquire()
#    global done
#    done = True
#    chlock.release()
#    sys.exit()
    
#  def startProducing(self):
#    producer = RandomCharacterGenerator();
#    self.displayCanvas.setCharacterSource(producer)
#    producer.start()
    
#  def addCharacterListener(self, listener ):
#    self.handler.addCharacterListener(listener)
    
#  def removeCharacterListener(self, listener ):
#    self.handler.removeCharacterListener(listener)
    
#  def nextCharacter(self):
#    pass
    
  
    
    
#if __name__ == '__main__': SwingTypeTester().mainloop()  # if I'm run as a script    
    
