# AtomicDEVS model: Generator 


from lib.DEVS import *
from lib.Simulator import *
from whrandom import *
from Job import *

class Generator(AtomicDEVS):
  Passive='Passive'
  Generating='Generating'
  INFINITY = 1000000

  def __init__(self, ia, ib, szl, szh):
    AtomicDEVS.__init__(self)
    self.ia = ia
    self.ib = ib
    self.szl = szl
    self.szh = szh
    self.state = Generator.Passive
    self.OUT = self.addOutPort()
    self.OUT.instName = 'OUT'
    self.OUT.instType = 'OutPort'

  def intTransition(self):
    if(self.state==Generator.Passive):
      return Generator.Generating
    elif(self.state==Generator.Generating):
      return Generator.Generating

  def timeAdvance(self):
    if(self.state==Generator.Passive):
      return randint(self.ia, self.ib)
    elif(self.state==Generator.Generating):
      return randint(self.ia, self.ib)

  def outputFnc(self):
    if(self.state==Generator.Passive):
      self.poke(self.OUT, Job(self.szl, self.szh))
    elif(self.state==Generator.Generating):
      self.poke(self.OUT, Job(self.szl, self.szh))