# muModelica Compiler Project
# Author: Steven Xu
# Modeling, Simulation and Design Lab (MSDL)
# School of Computer Science
# McGill University

from GraphManager.AGLLoader.AGLLoader import AGLLoader
from GraphManager.AGLGenerator.AGLGenerator import AGLGenerator

class XMLReader:
    "the XML reader"
    def __init__(self, id, XMLFilePath, catalogFilePath):
        self.mapping = {}
        self.mapping[id] = XMLFilePath
        self.loader = AGLLoader(self.mapping, catalogFilePath)
        #self.reader = AGLGenerator(self.mapping)

    def load(self, id):
        loadedGraph = self.loader.load(id)
        #print 'XML file loaded...'
        return loadedGraph



class XMLWriter:
    "the XML writer"
    def __init__(self, id, XMLFilePath, graph):
        self.mapping = {}
        self.mapping[id] = XMLFilePath
        #self.loader = AGLLoader(self.mapping, catalogFilePath)
        self.writer = AGLGenerator(graph, self.mapping)

    def write(self):
        self.writer.genCode()
        #print 'XML file generated...'
        return True
