model BouncingHead
  SlidingMass head(m=1.2);
  SlidingMass upperBody(m=14);
  SlidingMass arms(m=3.2);
  SlidingMass lowerBody(m=24);
  GvtForce headGvt(m=head.m);
  GvtForce upperBodyGvt(m=upperBody.m);
  GvtForce armsGvt(m=arms.m);
  GvtForce lowerBodyGvt(m=lowerBody.m);
  SpringDamper body_head(s_rel0=0.1, c=0.3, d=0.1*9.8)
        "SpringDamper connecting head and upperbody";
  SpringDamper body_arms(s_rel0=0.05, c=8, d=10*9.8)
        "SpringDamper connecting upperbody and arms";
  SpringDamper upper_lower_body(s_rel0=0.05, c=3, d=12*9.8)
        "SpringDamper connecting upperbody and lowerbody";
  SpringDamper fixed_lowerBody(s_rel0=0.05, c=1, d=10*9.8)
        "SpringDamper connecting lowerbody and fixed point";
  SineForce f "external input force";
  Fixed fixedPoint;
equation
  // connecting masses to forces
  connect(headGvt.flange_b, head.flange_a);
  connect(upperBodyGvt.flange_b, upperBody.flange_a);
  connect(armsGvt.flange_b, arms.flange_a);
  connect(lowerBodyGvt.flange_b, lowerBody.flange_a);
  connect(f.flange_b, lowerBody.flange_b);
  // connecting masses to SpringDampers
  connect(body_head.flange_a, head.flange_b);
  connect(body_head.flange_b, upperBody.flange_a);
  connect(body_arms.flange_a, upperBody.flange_b);
  connect(upperBody.flange_b, upper_lower_body.flange_a);
  connect(body_arms.flange_b, arms.flange_a);
  connect(upper_lower_body.flange_b, lowerBody.flange_a);
  connect(fixedPoint.flange_b, fixed_lowerBody.flange_b);
  connect(lowerBody.flange_b, fixed_lowerBody.flange_a);
end BouncingHHead;

