partial model Rigid
  "Rigid connection of two translational 1D flanges "
  Real s
    "absolute position of center of component (s = flange_a.s + L/2 = flange_b.s - L/2)";
  parameter Real L=0
    "length of component from left flange to right flange (= flange_b.s - flange_a.s)";
  Flange_a flange_a
    "(left) driving flange (flange axis directed INTO cut plane, i. e. from left to right)";
  Flange_b flange_b
    "(right) driven flange (flange axis directed OUT OF cut plane, i. e. from right to left)";
equation
  flange_a.s = s - L/2;
  flange_b.s = s + L/2;
end Rigid;

