// the predefined types in Modelica
package Predefined
type Real
  RealType value;
  parameter StringType quantity;
  parameter StringType unit;
  parameter StringType displayUnit;
  parameter RealType min;
  parameter RealType max;
  parameter RealType start;
  parameter BooleanType fixed;
  parameter BooleanType enable;
  parameter RealType nominal;
  parameter StateSelect stateSelect;
equation
  //assert(value >= min and value <= max, "Variable value out of limit");
  //assert(nominal >= min and nominal <= max, "Nominal value ot of limit");
end Real;

type Integer
  IntegerType value;
  parameter StringType quantity;
  parameter IntegerType min;
  parameter IntegerType max;
  parameter IntegerType start;
  parameter BooleanType fixed;
  parameter BooleanType enable;
equation
  //assert(value >= min and value <= max, "Variable value out of limit");
end Integer;

type Boolean
  BooleanType value;
  parameter StringType quantity;
  parameter BooleanType start;
  parameter BooleanType fixed;
  parameter BooleanType enable;
end Boolean;

type String
  StringType value;
  parameter StringType quantity = "";
  parameter StringType start;
  parameter BooleanType enable;
end String;

type StateSelect = enumeration(never, avoid, default, prefer, always);

class time
end time;

// this is the empty definition of the 'der' operator
function der
end der;

function sin
end sin;

function cos
end cos;

end Predefined;
