#Abstract class for graph elements.
#Implements common implementation for Node and Graph

#Author: Marc Provost
#Version: 1.1
#Date: June 16th,  2003

from GraphRepr.GraphElementInterface import GraphElementInterface

import exceptions
from exceptions import NotImplementedError

class GraphElement(GraphElementInterface):

    def __init__(self, id, type=None):
        raise NotImplementedError("Abstract Class")

    def addAttribute(self, name, value):
        self.__attributes[name] = value


    def getAttributesName(self):
        "returns a list with the name of the attributes"
        return self.__attributes.keys()

    def getAttrValue(self, attributeName):
        "returns the value associated with that attribute"
        if self.__attributes.has_key(attributeName):
            return self.__attributes[attributeName]
        else:
            raise InvalidAttributeException(attributeName,
                                            self.__attributes.keys())

    def setAttrValue(self, attributeName, value):
        "sets to 'value' the attribute specified"
        if self.__attributes.has_key(attributeName):
            self.__attributes[attributeName] = value
        else:
            raise InvalidAttributeException(attributeName,
                                            self.__attributes.keys())
    def getId(self):
        return self.__id

    def getType(self):
        return self.__type

    def __str__(self):
        pass

    def hasLocalId(self, ID):
        pass

    def getElement(self, elem_ID):
        pass

    def getElements(self):
        pass

    def addElement(self, elem, sources=[], targets=[]):
        pass

    def removeElement(self, ID):
        pass

    def connect(self, id_A, id_B):
        pass

    def disconnect(self, id_A, id_B):
        pass

    def getElemInC(self, elem_ID):
        pass

    def getElemOutC(self, elem_ID):
        pass

    def __str__(self):
        pass

    # enter action perfomed by a visitor on this element
    def enter(self, visitor):
        pass

    # exit action perfomed by a visitor on this element
    def exit(self, visitor):
        pass




