#Interface class for graph elements.
#Describe the minimal interface for
#any member of a graph.

#Author: Marc Provost
#Version: 1.1
#Date: June 16th, 2003

import exceptions
from exceptions import NotImplementedError

class GraphElementInterface:

    # Constructor for graph elements
    # id: str
    # type : GraphElement
    def __init__(self, id, type):
        raise NotImplementedError("Interface")

    # add an attribute to this GraphElement
    # name: str
    # value : GraphElement
    def addAttribute(self, name, value):
        pass

    # get the names of the attribute of this GraphElement
    # returnVal : List (str)
    def getAttributesName(self):
        pass

    # get the value of an attribute
    # attributeName : str
    # returnVal : GraphElement
    def getAttrValue(self, attributeName):
        pass

    # set the value of an attribute
    # name: str
    # value : GraphElement
    def setAttrValue(self, attributeName, value):
        pass

    # returns the id of this GraphElement
    # returnVal : str
    def getId(self):
        pass

    # returns the type of this GraphElement
    # returnVal : GraphElement
    def getType(self):
        pass

    # check if ID is present in this GraphElement (for Graph only)
    # returnVal : int
    def hasLocalId(self, ID):
        pass

    # returns the GraphElement with ID elem_ID member
    # of this Graph (for Graph only)
    # elem_ID : str
    # returnVal : GraphElement
    def getElement(self, elem_ID):
        pass

    # returns the GraphElements member
    # of this Graph (for Graph only)
    # returnVal : GraphDictCollection (GraphElement)
    def getElements(self):
        pass

    # add elem to this Graph (for Graph only)
    # connected from sources to targets (optionnal)
    # elem : GraphElement
    # sources : List (GraphElement id, member of this Graph)
    # targets : List (GraphElement id, member of this Graph)
    def addElement(self, elem, sources=[], targets=[]):
        pass

    # remove elem with id ID from this Graph (for Graph only)
    # ID : str
    def removeElement(self, ID):
        pass

    # connect elem with id == id_A to
    # elem with id == id_B (for Graph only)
    # id_A : str
    # id_B : str
    def connect(self, id_A, id_B):
        pass

    # disconnect elem with id == id_A to
    # elem with id == id_B (for Graph only)
    # id_A : str
    # id_B : str
    def disconnect(self, id_A, id_B):
        pass

    # get the GraphElements connected to elem with
    # id==elem_ID (for Graph only)
    # returnVal : GraphListCollection (GraphElement)
    def getElemInC(self, elem_ID):
        pass

    # get the GraphElements that elem with
    # id==elem_ID is connected to (for Graph only)
    # returnVal : GraphListCollection (GraphElement)
    def getElemOutC(self, elem_ID):
        pass

    # str repr of this GraphElement
    # returnVal : str
    def __str__(self):
        pass


    # enter action perfomed by a visitor on this element
    # visitor : Visitor
    def enter(self, visitor):
        pass

    # exit action perfomed by a visitor on this element
    # visitor : Visitor
    def exit(self, visitor):
        pass




