from GraphRepr.GraphUtils.Iterator import Iterator
from GraphRepr.GraphUtils.Error.IteratorException\
                            import NoMoreElementException,\
                                   TypeInvalidityException,\
                                   InvalidKeyException


class ElemIterator(Iterator):

    def __init__(self, elemDict, elemTypeList=None):

        if type(elemDict) != dict:
            raise TypeInvalidityException(type(elemDict), [type({})])
        if type(elemTypeList) != list and elemTypeList != None:
            raise TypeInvalidityException(type(elemTypeList), [type([]),
                                                           type(None)])

        self.__elementsLists=[]

        if elemTypeList == None:
            for key in elemDict.keys():
                currList = elemDict[key]
                if len(currList) > 0:
                    self.__elementsLists.append(currList)
        else:
            for elemType in elemTypeList:
                if elemDict.has_key(elemType):
                    currList=elemDict[elemType]
                    if len(currList) > 0:
                        self.__elementsLists.append(currList)

        self.listIndex=0
        self.elementIndex=0

    def first(self):
        self.listIndex=0
        self.elementIndex=0

    def next(self):

        if self.isDone():
            raise NoMoreElementException()
        else:
            if self.elementIndex ==\
                             len(self.__elementsLists[self.listIndex])-1:
                self.listIndex += 1
                self.elementIndex = 0
            else:
                self.elementIndex += 1

    def currentElement(self):

        if self.isDone():
            raise NoMoreElementException()
        else:
            return self.__elementsLists[self.listIndex][self.elementIndex]

    def isDone(self):
        return (len(self.__elementsLists)==0 or
               self.listIndex>=len(self.__elementsLists))


