class IteratorException(Exception):
    """Base class for exception in this module"""
    pass

class NoMoreElementException(IteratorException):

    def __init__(self):
        pass

    def __str__(self):
        return "\nNo more element to iterate\n"

class InvalidKeyException(IteratorException):

    def __init__(self, key):
        self.key=key

    def __str__(self):
        return "\nSpecified key is invalid: " + str(self.key)+"\n"

class TypeInvalidityException(IteratorException):

    def __init__(self, wrongType, expectedTypes):
        self.wrongType=wrongType
        self.expectedTypes=expectedTypes

    def __str__(self):
        answer = "\nInvalid type: " + str(self.wrongType) + "\n"+\
                 "Expected types: "

        for val in self.expectedTypes:
            answer += str(val) + " "

        return answer