from GraphRepr.GraphUtils.ConnIterator import ConnIterator

from GraphRepr.GraphUtils.Collection import Collection
from GraphRepr.GraphUtils.Error.CollectionException\
                            import InvalidElementException

class GraphConnCollection(Collection):

    def __sort(self, elemDict):
        elems=[]
        for key in elemDict.keys():
            elems.append(elemDict[key])
        elems.sort(lambda x, y: cmp(x[1], y[1]))
        return elems

    def getElementAt(self, pos):
        if not self.__sorted:
            self.__sortedElems=self.__sort(self.__elems)
            self.__sorted=1
        return self.__sortedElems[pos][0]

    def __getitem__(self, key):
        if not self.__sorted:
            self.__sortedElems=self.__sort(self.__elems)
            self.__sorted=1
        return self.__sortedElems[key][0]

    def __init__(self, dictOfElem):
        self.__elems=dictOfElem
        self.__sorted=0

    def size(self):
        return len(self.__elems)

    def hasElement(self, global_ID):
        if self.__elems.has_key(global_ID):
            return 1
        return 0

    def getIds(self):
        return self.__elems.keys()

    def keys(self):
        return self.__elems.keys()

    def getElement(self, global_ID):
        if not self.hasElement(global_ID):
            raise InvalidElementException(global_ID)
        return self.__elems[global_ID][0]

    def getOrd(self, global_ID):
        if not self.hasElement(global_ID):
            raise InvalidElementException(global_ID)
        return self.__elems[global_ID][1]

    def setOrdOfElement(self, global_ID, order):
        if not self.hasElement(global_ID):
            raise InvalidElementException(global_ID)
        self.__elems[global_ID][1]=order
        self.__sorted=0

    def getElementsOfOrd(self, order):
        ans=[]
        for key in self.__elems.keys():
            ORD=self.__elems[key][1]
            if ORD==order:
                ans.append(self.__elems[key][0])
        return ans

    def getElementsOfSmallerOrd(self, order):
        ans=[]
        for key in self.__elems.keys():
            ORD=self.__elems[key][1]
            if ORD<order:
                ans.append(self.__elems[key][0])
        return ans

    def getElementsOfLargerOrd(self, order):
        ans=[]
        for key in self.__elems.keys():
            ORD=self.__elems[key][1]
            if ORD>order:
                ans.append(self.__elems[key][0])
        return ans

    def getElementsOfType(self, typeName):
        answer = []
        for key in self.__elems.keys():
            elem=self.__elems[key][0]
            if elem.getTypeLocalId()==typeName:
                answer.append(self.__elems[key][0])

        return answer

    def getElements(self):
        answer=[]
        for key in self.__elems.keys():
            answer.append(self.__elems[key][0])
        answer.sort(lambda x, y: cmp(x[1], y[1]))
        return answer

    def iterate(self):
        return ConnIterator(self.__elems)

    def __str__(self):
        return str(self.__elems)

    def __repr__(self):
        return str(self.__elems)



