# Abstract Class CollectionType
# Authors Marc Provost
# Super class for the hard-coded collection types:
# For now: List (possibly: Set, Tuple)

from GraphRepr.Node import Node
from GraphRepr.Graph import Graph

import exceptions
from exceptions import NotImplementedError

class CollectionType:

    TYPE=Graph("CollectionType")
    TYPE.addElement(Node("CollectionType"))
    TYPE.addElement(Node("List", type="CollectionType"))

    def __init__(self, LIST=[]):
        raise NotImplementedError("Abstract Class")

    # Add an element to this collection
    # elem : GraphElement
    def addElement(self, elem):
        pass

    # Remove an element to this collection
    # elem : GraphElement
    def removeElement(self, elem):
        pass

    # Check if elem is member of this collection
    # elem : GraphElement
    def hasElement(self, elem):
        pass

    # Returns an iterator over this collection
    # returnVal: Iterator
    def iterate(self, type=None):
        pass

    # returns the size of this collection
    # returnVal: int
    def size(self):
        pass

    def __str__(self):
        pass

    # OVERLOADING METHODS

    def __getitem__(self, key):
        pass

    def __setitem__(self, key, item):
        pass

    def __delitem__(self, key):
        pass

    def __contains__(self, key):
        pass

    def __len__(self, obj):
        pass

    def __hash__(self):
        pass

    def __str__(self):
        pass