from GraphRepr.Types.SimpleType.Int import Int
from GraphRepr.Types.SimpleType.Bool import Bool
from GraphRepr.Types.SimpleType.String import String
from GraphRepr.Types.SimpleType.Float import Float

from GraphRepr.Types.CollectionType.List import List

from GraphRepr.Graph import Graph
from GraphRepr.Node import Node

import unittest

class CollectionTypeSuccess(unittest.TestCase):

    sampleSuccess = [ [Int(5), Bool("true"), String("blah"),
                       Float(4.5), Int(10)]
                 ]

    def testBasicList(self):
        """Testing List
        """

        for sample in self.sampleSuccess:
            lst = List()

            for elem in sample:
                lst.addElement(elem)

            self.failIf(len(sample) != lst.size(),
                        "sizes do not correspond")

            for el in sample:
                self.failIf(not lst.hasElement(el),
                            "some element is not present!")

            lst.removeElement(sample[0])

            self.failIf(lst.hasElement(sample[0]),
                        "a removed element is still there")





if __name__ == "__main__":
    unittest.main()



