class SimpleTypeException(Exception):
    """Base class for exception in this module"""
    pass

class TypeInvalidityException(SimpleTypeException):

    def __init__(self, wrongType, expectedTypes):
        self.wrongType=wrongType
        self.expectedTypes=expectedTypes

    def __str__(self):
        answer = "\nInvalid type: " + str(self.wrongType) + "\n"+\
                 "Expected types: "

        for val in self.expectedTypes:
            answer += str(val) + " "

        return answer

class ValueException(SimpleTypeException):

    def __init__(self, value, expectedValues):
        self.value=value
        self.expectedValues=expectedValues

    def __str__(self):
        answer = "\nWrong value: " + str(self.value) + "\n" +\
                 "Expected values: "

        for val in self.expectedValues:
            answer += val + " "

        return answer

