
import sys
import os.path
sys.path.append(os.path.expanduser('pydevs/'))
from DEVS import *
from infinity import *
from random import randint
from simulator import *

class GeneratorState:
  generating = 'generating'
  def __init__(self):
    
    self.seqState = self.generating

  def __str__(self):
    strRep = ''
    strRep = strRep + "\nseqState: " + str(self.seqState)
    return strRep

  def toXML(self):
    strRep = ''
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>seqState</name>"
    strRep = strRep + "\n\t<type>Generator_SeqStates</type>"
    strRep = strRep + "\n\t<value>"+str(self.seqState)+"</value>"
    strRep = strRep + "\n</attribute>"
    return strRep

class ProcessorState:
  idle = 'idle'
  state_2 = 'state_2'
  def __init__(self):
    
    self.seqState = self.idle

  def __str__(self):
    strRep = ''
    strRep = strRep + "\nseqState: " + str(self.seqState)
    return strRep

  def toXML(self):
    strRep = ''
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>seqState</name>"
    strRep = strRep + "\n\t<type>Processor_SeqStates</type>"
    strRep = strRep + "\n\t<value>"+str(self.seqState)+"</value>"
    strRep = strRep + "\n</attribute>"
    return strRep

class Root( AtomicDEVS ):
  def __init__(self):
    AtomicDEVS.__init__(self)
    self.p_out = self.addOutPort("p_out")
    self.X = dict()
    self.timeLefts = None
    self.elapsed = 0
    self.ins_0_state = GeneratorState()
    self.ins_0_timeLeft = self.timeAdvance_Generator(self.ins_0_state)
    self.ins_0_elapsed = 0
    self.ins_1_state = ProcessorState()
    self.ins_1_timeLeft = self.timeAdvance_Processor(self.ins_1_state)
    self.ins_1_elapsed = 0
    self.ins_2_state = ProcessorState()
    self.ins_2_timeLeft = self.timeAdvance_Processor(self.ins_2_state)
    self.ins_2_elapsed = 0
    self.ins_3_state = ProcessorState()
    self.ins_3_timeLeft = self.timeAdvance_Processor(self.ins_3_state)
    self.ins_3_elapsed = 0
    self.ins_4_state = ProcessorState()
    self.ins_4_timeLeft = self.timeAdvance_Processor(self.ins_4_state)
    self.ins_4_elapsed = 0
    self.ins_5_state = ProcessorState()
    self.ins_5_timeLeft = self.timeAdvance_Processor(self.ins_5_state)
    self.ins_5_elapsed = 0
    self.ins_6_state = ProcessorState()
    self.ins_6_timeLeft = self.timeAdvance_Processor(self.ins_6_state)
    self.ins_6_elapsed = 0
    self.ins_7_state = ProcessorState()
    self.ins_7_timeLeft = self.timeAdvance_Processor(self.ins_7_state)
    self.ins_7_elapsed = 0
    self.ins_8_state = ProcessorState()
    self.ins_8_timeLeft = self.timeAdvance_Processor(self.ins_8_state)
    self.ins_8_elapsed = 0
    self.ins_9_state = ProcessorState()
    self.ins_9_timeLeft = self.timeAdvance_Processor(self.ins_9_state)
    self.ins_9_elapsed = 0
    self.ins_10_state = ProcessorState()
    self.ins_10_timeLeft = self.timeAdvance_Processor(self.ins_10_state)
    self.ins_10_elapsed = 0
    self.ins_11_state = ProcessorState()
    self.ins_11_timeLeft = self.timeAdvance_Processor(self.ins_11_state)
    self.ins_11_elapsed = 0
    self.ins_12_state = ProcessorState()
    self.ins_12_timeLeft = self.timeAdvance_Processor(self.ins_12_state)
    self.ins_12_elapsed = 0
    self.ins_13_state = ProcessorState()
    self.ins_13_timeLeft = self.timeAdvance_Processor(self.ins_13_state)
    self.ins_13_elapsed = 0
    self.ins_14_state = ProcessorState()
    self.ins_14_timeLeft = self.timeAdvance_Processor(self.ins_14_state)
    self.ins_14_elapsed = 0
    self.ins_15_state = ProcessorState()
    self.ins_15_timeLeft = self.timeAdvance_Processor(self.ins_15_state)
    self.ins_15_elapsed = 0
    self.ins_16_state = ProcessorState()
    self.ins_16_timeLeft = self.timeAdvance_Processor(self.ins_16_state)
    self.ins_16_elapsed = 0
    self.ins_17_state = ProcessorState()
    self.ins_17_timeLeft = self.timeAdvance_Processor(self.ins_17_state)
    self.ins_17_elapsed = 0
    self.ins_18_state = ProcessorState()
    self.ins_18_timeLeft = self.timeAdvance_Processor(self.ins_18_state)
    self.ins_18_elapsed = 0
    self.ins_19_state = ProcessorState()
    self.ins_19_timeLeft = self.timeAdvance_Processor(self.ins_19_state)
    self.ins_19_elapsed = 0
    self.ins_20_state = ProcessorState()
    self.ins_20_timeLeft = self.timeAdvance_Processor(self.ins_20_state)
    self.ins_20_elapsed = 0
    self.ins_21_state = ProcessorState()
    self.ins_21_timeLeft = self.timeAdvance_Processor(self.ins_21_state)
    self.ins_21_elapsed = 0
    self.ins_22_state = ProcessorState()
    self.ins_22_timeLeft = self.timeAdvance_Processor(self.ins_22_state)
    self.ins_22_elapsed = 0
    self.ins_23_state = ProcessorState()
    self.ins_23_timeLeft = self.timeAdvance_Processor(self.ins_23_state)
    self.ins_23_elapsed = 0
    self.ins_24_state = ProcessorState()
    self.ins_24_timeLeft = self.timeAdvance_Processor(self.ins_24_state)
    self.ins_24_elapsed = 0
    self.ins_25_state = ProcessorState()
    self.ins_25_timeLeft = self.timeAdvance_Processor(self.ins_25_state)
    self.ins_25_elapsed = 0
    self.ins_26_state = ProcessorState()
    self.ins_26_timeLeft = self.timeAdvance_Processor(self.ins_26_state)
    self.ins_26_elapsed = 0
    self.ins_27_state = ProcessorState()
    self.ins_27_timeLeft = self.timeAdvance_Processor(self.ins_27_state)
    self.ins_27_elapsed = 0
    self.ins_28_state = ProcessorState()
    self.ins_28_timeLeft = self.timeAdvance_Processor(self.ins_28_state)
    self.ins_28_elapsed = 0
    self.ins_29_state = ProcessorState()
    self.ins_29_timeLeft = self.timeAdvance_Processor(self.ins_29_state)
    self.ins_29_elapsed = 0
    self.ins_30_state = ProcessorState()
    self.ins_30_timeLeft = self.timeAdvance_Processor(self.ins_30_state)
    self.ins_30_elapsed = 0
    self.ins_31_state = ProcessorState()
    self.ins_31_timeLeft = self.timeAdvance_Processor(self.ins_31_state)
    self.ins_31_elapsed = 0
    self.ins_32_state = ProcessorState()
    self.ins_32_timeLeft = self.timeAdvance_Processor(self.ins_32_state)
    self.ins_32_elapsed = 0
    self.ins_33_state = ProcessorState()
    self.ins_33_timeLeft = self.timeAdvance_Processor(self.ins_33_state)
    self.ins_33_elapsed = 0
    self.ins_34_state = ProcessorState()
    self.ins_34_timeLeft = self.timeAdvance_Processor(self.ins_34_state)
    self.ins_34_elapsed = 0
    self.ins_35_state = ProcessorState()
    self.ins_35_timeLeft = self.timeAdvance_Processor(self.ins_35_state)
    self.ins_35_elapsed = 0
    self.ins_36_state = ProcessorState()
    self.ins_36_timeLeft = self.timeAdvance_Processor(self.ins_36_state)
    self.ins_36_elapsed = 0
    self.ins_37_state = ProcessorState()
    self.ins_37_timeLeft = self.timeAdvance_Processor(self.ins_37_state)
    self.ins_37_elapsed = 0
    self.ins_38_state = ProcessorState()
    self.ins_38_timeLeft = self.timeAdvance_Processor(self.ins_38_state)
    self.ins_38_elapsed = 0
    self.ins_39_state = ProcessorState()
    self.ins_39_timeLeft = self.timeAdvance_Processor(self.ins_39_state)
    self.ins_39_elapsed = 0
    self.ins_40_state = ProcessorState()
    self.ins_40_timeLeft = self.timeAdvance_Processor(self.ins_40_state)
    self.ins_40_elapsed = 0
    self.ins_41_state = ProcessorState()
    self.ins_41_timeLeft = self.timeAdvance_Processor(self.ins_41_state)
    self.ins_41_elapsed = 0
    self.ins_42_state = ProcessorState()
    self.ins_42_timeLeft = self.timeAdvance_Processor(self.ins_42_state)
    self.ins_42_elapsed = 0
    self.ins_43_state = ProcessorState()
    self.ins_43_timeLeft = self.timeAdvance_Processor(self.ins_43_state)
    self.ins_43_elapsed = 0
    self.ins_44_state = ProcessorState()
    self.ins_44_timeLeft = self.timeAdvance_Processor(self.ins_44_state)
    self.ins_44_elapsed = 0
    self.ins_45_state = ProcessorState()
    self.ins_45_timeLeft = self.timeAdvance_Processor(self.ins_45_state)
    self.ins_45_elapsed = 0
    self.ins_46_state = ProcessorState()
    self.ins_46_timeLeft = self.timeAdvance_Processor(self.ins_46_state)
    self.ins_46_elapsed = 0
    self.ins_47_state = ProcessorState()
    self.ins_47_timeLeft = self.timeAdvance_Processor(self.ins_47_state)
    self.ins_47_elapsed = 0
    self.ins_48_state = ProcessorState()
    self.ins_48_timeLeft = self.timeAdvance_Processor(self.ins_48_state)
    self.ins_48_elapsed = 0
    self.ins_49_state = ProcessorState()
    self.ins_49_timeLeft = self.timeAdvance_Processor(self.ins_49_state)
    self.ins_49_elapsed = 0
    self.ins_50_state = ProcessorState()
    self.ins_50_timeLeft = self.timeAdvance_Processor(self.ins_50_state)
    self.ins_50_elapsed = 0
    
  def intTransition_Generator( self, state ):
    if(state.seqState == GeneratorState.generating):
      state.seqState = GeneratorState.generating
    return state

  
  def outputFnc_Generator( self, state ):
    Y=dict()
    evt = None
    if(state.seqState == GeneratorState.generating):
      evt = Job(0.3)
      Y["p_out"] = evt
    return Y

  
  def timeAdvance_Generator( self, state ):
    if(state.seqState == GeneratorState.generating):
      timespan = 1
    return timespan

  
  def extTransition_Processor( self, state, X, elapsed ):
    if(state.seqState == ProcessorState.idle):
      state.seqState = ProcessorState.state_2
      self.event = X.get("p_in", None)
    return state

  
  def intTransition_Processor( self, state ):
    if(state.seqState == ProcessorState.state_2):
      state.seqState = ProcessorState.idle
    return state

  
  def outputFnc_Processor( self, state ):
    Y=dict()
    evt = None
    if(state.seqState == ProcessorState.state_2):
      Y["p_out"] = self.event
    return Y

  
  def timeAdvance_Processor( self, state ):
    if(state.seqState == ProcessorState.idle):
      timespan = INFINITY

    if(state.seqState == ProcessorState.state_2):
      timespan = self.event.jobSize
    return timespan

  
  def get_dstar( self ):
    minimal = 0
    elems = list()
    minimal = self.timeAdvance()

    if(self.ins_0_timeLeft < minimal + 1e-10):
      elems.append(self.ins_0_state)

    if(self.ins_1_timeLeft < minimal + 1e-10):
      elems.append(self.ins_1_state)

    if(self.ins_2_timeLeft < minimal + 1e-10):
      elems.append(self.ins_2_state)

    if(self.ins_3_timeLeft < minimal + 1e-10):
      elems.append(self.ins_3_state)

    if(self.ins_4_timeLeft < minimal + 1e-10):
      elems.append(self.ins_4_state)

    if(self.ins_5_timeLeft < minimal + 1e-10):
      elems.append(self.ins_5_state)

    if(self.ins_6_timeLeft < minimal + 1e-10):
      elems.append(self.ins_6_state)

    if(self.ins_7_timeLeft < minimal + 1e-10):
      elems.append(self.ins_7_state)

    if(self.ins_8_timeLeft < minimal + 1e-10):
      elems.append(self.ins_8_state)

    if(self.ins_9_timeLeft < minimal + 1e-10):
      elems.append(self.ins_9_state)

    if(self.ins_10_timeLeft < minimal + 1e-10):
      elems.append(self.ins_10_state)

    if(self.ins_11_timeLeft < minimal + 1e-10):
      elems.append(self.ins_11_state)

    if(self.ins_12_timeLeft < minimal + 1e-10):
      elems.append(self.ins_12_state)

    if(self.ins_13_timeLeft < minimal + 1e-10):
      elems.append(self.ins_13_state)

    if(self.ins_14_timeLeft < minimal + 1e-10):
      elems.append(self.ins_14_state)

    if(self.ins_15_timeLeft < minimal + 1e-10):
      elems.append(self.ins_15_state)

    if(self.ins_16_timeLeft < minimal + 1e-10):
      elems.append(self.ins_16_state)

    if(self.ins_17_timeLeft < minimal + 1e-10):
      elems.append(self.ins_17_state)

    if(self.ins_18_timeLeft < minimal + 1e-10):
      elems.append(self.ins_18_state)

    if(self.ins_19_timeLeft < minimal + 1e-10):
      elems.append(self.ins_19_state)

    if(self.ins_20_timeLeft < minimal + 1e-10):
      elems.append(self.ins_20_state)

    if(self.ins_21_timeLeft < minimal + 1e-10):
      elems.append(self.ins_21_state)

    if(self.ins_22_timeLeft < minimal + 1e-10):
      elems.append(self.ins_22_state)

    if(self.ins_23_timeLeft < minimal + 1e-10):
      elems.append(self.ins_23_state)

    if(self.ins_24_timeLeft < minimal + 1e-10):
      elems.append(self.ins_24_state)

    if(self.ins_25_timeLeft < minimal + 1e-10):
      elems.append(self.ins_25_state)

    if(self.ins_26_timeLeft < minimal + 1e-10):
      elems.append(self.ins_26_state)

    if(self.ins_27_timeLeft < minimal + 1e-10):
      elems.append(self.ins_27_state)

    if(self.ins_28_timeLeft < minimal + 1e-10):
      elems.append(self.ins_28_state)

    if(self.ins_29_timeLeft < minimal + 1e-10):
      elems.append(self.ins_29_state)

    if(self.ins_30_timeLeft < minimal + 1e-10):
      elems.append(self.ins_30_state)

    if(self.ins_31_timeLeft < minimal + 1e-10):
      elems.append(self.ins_31_state)

    if(self.ins_32_timeLeft < minimal + 1e-10):
      elems.append(self.ins_32_state)

    if(self.ins_33_timeLeft < minimal + 1e-10):
      elems.append(self.ins_33_state)

    if(self.ins_34_timeLeft < minimal + 1e-10):
      elems.append(self.ins_34_state)

    if(self.ins_35_timeLeft < minimal + 1e-10):
      elems.append(self.ins_35_state)

    if(self.ins_36_timeLeft < minimal + 1e-10):
      elems.append(self.ins_36_state)

    if(self.ins_37_timeLeft < minimal + 1e-10):
      elems.append(self.ins_37_state)

    if(self.ins_38_timeLeft < minimal + 1e-10):
      elems.append(self.ins_38_state)

    if(self.ins_39_timeLeft < minimal + 1e-10):
      elems.append(self.ins_39_state)

    if(self.ins_40_timeLeft < minimal + 1e-10):
      elems.append(self.ins_40_state)

    if(self.ins_41_timeLeft < minimal + 1e-10):
      elems.append(self.ins_41_state)

    if(self.ins_42_timeLeft < minimal + 1e-10):
      elems.append(self.ins_42_state)

    if(self.ins_43_timeLeft < minimal + 1e-10):
      elems.append(self.ins_43_state)

    if(self.ins_44_timeLeft < minimal + 1e-10):
      elems.append(self.ins_44_state)

    if(self.ins_45_timeLeft < minimal + 1e-10):
      elems.append(self.ins_45_state)

    if(self.ins_46_timeLeft < minimal + 1e-10):
      elems.append(self.ins_46_state)

    if(self.ins_47_timeLeft < minimal + 1e-10):
      elems.append(self.ins_47_state)

    if(self.ins_48_timeLeft < minimal + 1e-10):
      elems.append(self.ins_48_state)

    if(self.ins_49_timeLeft < minimal + 1e-10):
      elems.append(self.ins_49_state)

    if(self.ins_50_timeLeft < minimal + 1e-10):
      elems.append(self.ins_50_state)

    if(len(elems) > 1):
      dStar = self.select(elems)
    else:
      dStar = elems[0]
    return dStar

  
  def intTransition( self ):
    counter = 0
    new = list()
    transitioned = list()
    first = list()
    elems = list()
    ta = 0.0
    Y_inst = dict()
    dStar = None
    new = list()

    counter = 0

    self.ins_0_timeLeft = self.ins_0_timeLeft - self.elapsed

    self.ins_1_timeLeft = self.ins_1_timeLeft - self.elapsed

    self.ins_2_timeLeft = self.ins_2_timeLeft - self.elapsed

    self.ins_3_timeLeft = self.ins_3_timeLeft - self.elapsed

    self.ins_4_timeLeft = self.ins_4_timeLeft - self.elapsed

    self.ins_5_timeLeft = self.ins_5_timeLeft - self.elapsed

    self.ins_6_timeLeft = self.ins_6_timeLeft - self.elapsed

    self.ins_7_timeLeft = self.ins_7_timeLeft - self.elapsed

    self.ins_8_timeLeft = self.ins_8_timeLeft - self.elapsed

    self.ins_9_timeLeft = self.ins_9_timeLeft - self.elapsed

    self.ins_10_timeLeft = self.ins_10_timeLeft - self.elapsed

    self.ins_11_timeLeft = self.ins_11_timeLeft - self.elapsed

    self.ins_12_timeLeft = self.ins_12_timeLeft - self.elapsed

    self.ins_13_timeLeft = self.ins_13_timeLeft - self.elapsed

    self.ins_14_timeLeft = self.ins_14_timeLeft - self.elapsed

    self.ins_15_timeLeft = self.ins_15_timeLeft - self.elapsed

    self.ins_16_timeLeft = self.ins_16_timeLeft - self.elapsed

    self.ins_17_timeLeft = self.ins_17_timeLeft - self.elapsed

    self.ins_18_timeLeft = self.ins_18_timeLeft - self.elapsed

    self.ins_19_timeLeft = self.ins_19_timeLeft - self.elapsed

    self.ins_20_timeLeft = self.ins_20_timeLeft - self.elapsed

    self.ins_21_timeLeft = self.ins_21_timeLeft - self.elapsed

    self.ins_22_timeLeft = self.ins_22_timeLeft - self.elapsed

    self.ins_23_timeLeft = self.ins_23_timeLeft - self.elapsed

    self.ins_24_timeLeft = self.ins_24_timeLeft - self.elapsed

    self.ins_25_timeLeft = self.ins_25_timeLeft - self.elapsed

    self.ins_26_timeLeft = self.ins_26_timeLeft - self.elapsed

    self.ins_27_timeLeft = self.ins_27_timeLeft - self.elapsed

    self.ins_28_timeLeft = self.ins_28_timeLeft - self.elapsed

    self.ins_29_timeLeft = self.ins_29_timeLeft - self.elapsed

    self.ins_30_timeLeft = self.ins_30_timeLeft - self.elapsed

    self.ins_31_timeLeft = self.ins_31_timeLeft - self.elapsed

    self.ins_32_timeLeft = self.ins_32_timeLeft - self.elapsed

    self.ins_33_timeLeft = self.ins_33_timeLeft - self.elapsed

    self.ins_34_timeLeft = self.ins_34_timeLeft - self.elapsed

    self.ins_35_timeLeft = self.ins_35_timeLeft - self.elapsed

    self.ins_36_timeLeft = self.ins_36_timeLeft - self.elapsed

    self.ins_37_timeLeft = self.ins_37_timeLeft - self.elapsed

    self.ins_38_timeLeft = self.ins_38_timeLeft - self.elapsed

    self.ins_39_timeLeft = self.ins_39_timeLeft - self.elapsed

    self.ins_40_timeLeft = self.ins_40_timeLeft - self.elapsed

    self.ins_41_timeLeft = self.ins_41_timeLeft - self.elapsed

    self.ins_42_timeLeft = self.ins_42_timeLeft - self.elapsed

    self.ins_43_timeLeft = self.ins_43_timeLeft - self.elapsed

    self.ins_44_timeLeft = self.ins_44_timeLeft - self.elapsed

    self.ins_45_timeLeft = self.ins_45_timeLeft - self.elapsed

    self.ins_46_timeLeft = self.ins_46_timeLeft - self.elapsed

    self.ins_47_timeLeft = self.ins_47_timeLeft - self.elapsed

    self.ins_48_timeLeft = self.ins_48_timeLeft - self.elapsed

    self.ins_49_timeLeft = self.ins_49_timeLeft - self.elapsed

    self.ins_50_timeLeft = self.ins_50_timeLeft - self.elapsed

    self.ins_0_elapsed = self.ins_0_elapsed + self.elapsed

    self.ins_1_elapsed = self.ins_1_elapsed + self.elapsed

    self.ins_2_elapsed = self.ins_2_elapsed + self.elapsed

    self.ins_3_elapsed = self.ins_3_elapsed + self.elapsed

    self.ins_4_elapsed = self.ins_4_elapsed + self.elapsed

    self.ins_5_elapsed = self.ins_5_elapsed + self.elapsed

    self.ins_6_elapsed = self.ins_6_elapsed + self.elapsed

    self.ins_7_elapsed = self.ins_7_elapsed + self.elapsed

    self.ins_8_elapsed = self.ins_8_elapsed + self.elapsed

    self.ins_9_elapsed = self.ins_9_elapsed + self.elapsed

    self.ins_10_elapsed = self.ins_10_elapsed + self.elapsed

    self.ins_11_elapsed = self.ins_11_elapsed + self.elapsed

    self.ins_12_elapsed = self.ins_12_elapsed + self.elapsed

    self.ins_13_elapsed = self.ins_13_elapsed + self.elapsed

    self.ins_14_elapsed = self.ins_14_elapsed + self.elapsed

    self.ins_15_elapsed = self.ins_15_elapsed + self.elapsed

    self.ins_16_elapsed = self.ins_16_elapsed + self.elapsed

    self.ins_17_elapsed = self.ins_17_elapsed + self.elapsed

    self.ins_18_elapsed = self.ins_18_elapsed + self.elapsed

    self.ins_19_elapsed = self.ins_19_elapsed + self.elapsed

    self.ins_20_elapsed = self.ins_20_elapsed + self.elapsed

    self.ins_21_elapsed = self.ins_21_elapsed + self.elapsed

    self.ins_22_elapsed = self.ins_22_elapsed + self.elapsed

    self.ins_23_elapsed = self.ins_23_elapsed + self.elapsed

    self.ins_24_elapsed = self.ins_24_elapsed + self.elapsed

    self.ins_25_elapsed = self.ins_25_elapsed + self.elapsed

    self.ins_26_elapsed = self.ins_26_elapsed + self.elapsed

    self.ins_27_elapsed = self.ins_27_elapsed + self.elapsed

    self.ins_28_elapsed = self.ins_28_elapsed + self.elapsed

    self.ins_29_elapsed = self.ins_29_elapsed + self.elapsed

    self.ins_30_elapsed = self.ins_30_elapsed + self.elapsed

    self.ins_31_elapsed = self.ins_31_elapsed + self.elapsed

    self.ins_32_elapsed = self.ins_32_elapsed + self.elapsed

    self.ins_33_elapsed = self.ins_33_elapsed + self.elapsed

    self.ins_34_elapsed = self.ins_34_elapsed + self.elapsed

    self.ins_35_elapsed = self.ins_35_elapsed + self.elapsed

    self.ins_36_elapsed = self.ins_36_elapsed + self.elapsed

    self.ins_37_elapsed = self.ins_37_elapsed + self.elapsed

    self.ins_38_elapsed = self.ins_38_elapsed + self.elapsed

    self.ins_39_elapsed = self.ins_39_elapsed + self.elapsed

    self.ins_40_elapsed = self.ins_40_elapsed + self.elapsed

    self.ins_41_elapsed = self.ins_41_elapsed + self.elapsed

    self.ins_42_elapsed = self.ins_42_elapsed + self.elapsed

    self.ins_43_elapsed = self.ins_43_elapsed + self.elapsed

    self.ins_44_elapsed = self.ins_44_elapsed + self.elapsed

    self.ins_45_elapsed = self.ins_45_elapsed + self.elapsed

    self.ins_46_elapsed = self.ins_46_elapsed + self.elapsed

    self.ins_47_elapsed = self.ins_47_elapsed + self.elapsed

    self.ins_48_elapsed = self.ins_48_elapsed + self.elapsed

    self.ins_49_elapsed = self.ins_49_elapsed + self.elapsed

    self.ins_50_elapsed = self.ins_50_elapsed + self.elapsed

    dStar = self.get_dstar()

    if(dStar == self.ins_0_state):
      self.Y = self.outputFnc_Generator(self.ins_0_state)
      self.ins_0_state = self.intTransition_Generator(self.ins_0_state)
      self.Y = self.renamePorts(self.Y, "ins_0")
      self.Y = self.mapConnections(self.Y)
      self.ins_0_timeLeft = self.timeAdvance_Generator(self.ins_0_state)
      self.ins_0_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_1")
      self.ins_1_state = self.extTransition_Processor(self.ins_1_state, Y_inst, self.elapsed)
      self.ins_1_timeLeft = self.timeAdvance_Processor(self.ins_1_state)
      self.ins_1_elapsed = 0

    if(dStar == self.ins_1_state):
      self.Y = self.outputFnc_Processor(self.ins_1_state)
      self.ins_1_state = self.intTransition_Processor(self.ins_1_state)
      self.Y = self.renamePorts(self.Y, "ins_1")
      self.Y = self.mapConnections(self.Y)
      self.ins_1_timeLeft = self.timeAdvance_Processor(self.ins_1_state)
      self.ins_1_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_2")
      self.ins_2_state = self.extTransition_Processor(self.ins_2_state, Y_inst, self.elapsed)
      self.ins_2_timeLeft = self.timeAdvance_Processor(self.ins_2_state)
      self.ins_2_elapsed = 0

    if(dStar == self.ins_2_state):
      self.Y = self.outputFnc_Processor(self.ins_2_state)
      self.ins_2_state = self.intTransition_Processor(self.ins_2_state)
      self.Y = self.renamePorts(self.Y, "ins_2")
      self.Y = self.mapConnections(self.Y)
      self.ins_2_timeLeft = self.timeAdvance_Processor(self.ins_2_state)
      self.ins_2_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_3")
      self.ins_3_state = self.extTransition_Processor(self.ins_3_state, Y_inst, self.elapsed)
      self.ins_3_timeLeft = self.timeAdvance_Processor(self.ins_3_state)
      self.ins_3_elapsed = 0

    if(dStar == self.ins_3_state):
      self.Y = self.outputFnc_Processor(self.ins_3_state)
      self.ins_3_state = self.intTransition_Processor(self.ins_3_state)
      self.Y = self.renamePorts(self.Y, "ins_3")
      self.Y = self.mapConnections(self.Y)
      self.ins_3_timeLeft = self.timeAdvance_Processor(self.ins_3_state)
      self.ins_3_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_4")
      self.ins_4_state = self.extTransition_Processor(self.ins_4_state, Y_inst, self.elapsed)
      self.ins_4_timeLeft = self.timeAdvance_Processor(self.ins_4_state)
      self.ins_4_elapsed = 0

    if(dStar == self.ins_4_state):
      self.Y = self.outputFnc_Processor(self.ins_4_state)
      self.ins_4_state = self.intTransition_Processor(self.ins_4_state)
      self.Y = self.renamePorts(self.Y, "ins_4")
      self.Y = self.mapConnections(self.Y)
      self.ins_4_timeLeft = self.timeAdvance_Processor(self.ins_4_state)
      self.ins_4_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_5")
      self.ins_5_state = self.extTransition_Processor(self.ins_5_state, Y_inst, self.elapsed)
      self.ins_5_timeLeft = self.timeAdvance_Processor(self.ins_5_state)
      self.ins_5_elapsed = 0

    if(dStar == self.ins_5_state):
      self.Y = self.outputFnc_Processor(self.ins_5_state)
      self.ins_5_state = self.intTransition_Processor(self.ins_5_state)
      self.Y = self.renamePorts(self.Y, "ins_5")
      self.Y = self.mapConnections(self.Y)
      self.ins_5_timeLeft = self.timeAdvance_Processor(self.ins_5_state)
      self.ins_5_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_6")
      self.ins_6_state = self.extTransition_Processor(self.ins_6_state, Y_inst, self.elapsed)
      self.ins_6_timeLeft = self.timeAdvance_Processor(self.ins_6_state)
      self.ins_6_elapsed = 0

    if(dStar == self.ins_6_state):
      self.Y = self.outputFnc_Processor(self.ins_6_state)
      self.ins_6_state = self.intTransition_Processor(self.ins_6_state)
      self.Y = self.renamePorts(self.Y, "ins_6")
      self.Y = self.mapConnections(self.Y)
      self.ins_6_timeLeft = self.timeAdvance_Processor(self.ins_6_state)
      self.ins_6_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_7")
      self.ins_7_state = self.extTransition_Processor(self.ins_7_state, Y_inst, self.elapsed)
      self.ins_7_timeLeft = self.timeAdvance_Processor(self.ins_7_state)
      self.ins_7_elapsed = 0

    if(dStar == self.ins_7_state):
      self.Y = self.outputFnc_Processor(self.ins_7_state)
      self.ins_7_state = self.intTransition_Processor(self.ins_7_state)
      self.Y = self.renamePorts(self.Y, "ins_7")
      self.Y = self.mapConnections(self.Y)
      self.ins_7_timeLeft = self.timeAdvance_Processor(self.ins_7_state)
      self.ins_7_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_8")
      self.ins_8_state = self.extTransition_Processor(self.ins_8_state, Y_inst, self.elapsed)
      self.ins_8_timeLeft = self.timeAdvance_Processor(self.ins_8_state)
      self.ins_8_elapsed = 0

    if(dStar == self.ins_8_state):
      self.Y = self.outputFnc_Processor(self.ins_8_state)
      self.ins_8_state = self.intTransition_Processor(self.ins_8_state)
      self.Y = self.renamePorts(self.Y, "ins_8")
      self.Y = self.mapConnections(self.Y)
      self.ins_8_timeLeft = self.timeAdvance_Processor(self.ins_8_state)
      self.ins_8_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_9")
      self.ins_9_state = self.extTransition_Processor(self.ins_9_state, Y_inst, self.elapsed)
      self.ins_9_timeLeft = self.timeAdvance_Processor(self.ins_9_state)
      self.ins_9_elapsed = 0

    if(dStar == self.ins_9_state):
      self.Y = self.outputFnc_Processor(self.ins_9_state)
      self.ins_9_state = self.intTransition_Processor(self.ins_9_state)
      self.Y = self.renamePorts(self.Y, "ins_9")
      self.Y = self.mapConnections(self.Y)
      self.ins_9_timeLeft = self.timeAdvance_Processor(self.ins_9_state)
      self.ins_9_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_10")
      self.ins_10_state = self.extTransition_Processor(self.ins_10_state, Y_inst, self.elapsed)
      self.ins_10_timeLeft = self.timeAdvance_Processor(self.ins_10_state)
      self.ins_10_elapsed = 0

    if(dStar == self.ins_10_state):
      self.Y = self.outputFnc_Processor(self.ins_10_state)
      self.ins_10_state = self.intTransition_Processor(self.ins_10_state)
      self.Y = self.renamePorts(self.Y, "ins_10")
      self.Y = self.mapConnections(self.Y)
      self.ins_10_timeLeft = self.timeAdvance_Processor(self.ins_10_state)
      self.ins_10_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_11")
      self.ins_11_state = self.extTransition_Processor(self.ins_11_state, Y_inst, self.elapsed)
      self.ins_11_timeLeft = self.timeAdvance_Processor(self.ins_11_state)
      self.ins_11_elapsed = 0

    if(dStar == self.ins_11_state):
      self.Y = self.outputFnc_Processor(self.ins_11_state)
      self.ins_11_state = self.intTransition_Processor(self.ins_11_state)
      self.Y = self.renamePorts(self.Y, "ins_11")
      self.Y = self.mapConnections(self.Y)
      self.ins_11_timeLeft = self.timeAdvance_Processor(self.ins_11_state)
      self.ins_11_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_12")
      self.ins_12_state = self.extTransition_Processor(self.ins_12_state, Y_inst, self.elapsed)
      self.ins_12_timeLeft = self.timeAdvance_Processor(self.ins_12_state)
      self.ins_12_elapsed = 0

    if(dStar == self.ins_12_state):
      self.Y = self.outputFnc_Processor(self.ins_12_state)
      self.ins_12_state = self.intTransition_Processor(self.ins_12_state)
      self.Y = self.renamePorts(self.Y, "ins_12")
      self.Y = self.mapConnections(self.Y)
      self.ins_12_timeLeft = self.timeAdvance_Processor(self.ins_12_state)
      self.ins_12_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_13")
      self.ins_13_state = self.extTransition_Processor(self.ins_13_state, Y_inst, self.elapsed)
      self.ins_13_timeLeft = self.timeAdvance_Processor(self.ins_13_state)
      self.ins_13_elapsed = 0

    if(dStar == self.ins_13_state):
      self.Y = self.outputFnc_Processor(self.ins_13_state)
      self.ins_13_state = self.intTransition_Processor(self.ins_13_state)
      self.Y = self.renamePorts(self.Y, "ins_13")
      self.Y = self.mapConnections(self.Y)
      self.ins_13_timeLeft = self.timeAdvance_Processor(self.ins_13_state)
      self.ins_13_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_14")
      self.ins_14_state = self.extTransition_Processor(self.ins_14_state, Y_inst, self.elapsed)
      self.ins_14_timeLeft = self.timeAdvance_Processor(self.ins_14_state)
      self.ins_14_elapsed = 0

    if(dStar == self.ins_14_state):
      self.Y = self.outputFnc_Processor(self.ins_14_state)
      self.ins_14_state = self.intTransition_Processor(self.ins_14_state)
      self.Y = self.renamePorts(self.Y, "ins_14")
      self.Y = self.mapConnections(self.Y)
      self.ins_14_timeLeft = self.timeAdvance_Processor(self.ins_14_state)
      self.ins_14_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_15")
      self.ins_15_state = self.extTransition_Processor(self.ins_15_state, Y_inst, self.elapsed)
      self.ins_15_timeLeft = self.timeAdvance_Processor(self.ins_15_state)
      self.ins_15_elapsed = 0

    if(dStar == self.ins_15_state):
      self.Y = self.outputFnc_Processor(self.ins_15_state)
      self.ins_15_state = self.intTransition_Processor(self.ins_15_state)
      self.Y = self.renamePorts(self.Y, "ins_15")
      self.Y = self.mapConnections(self.Y)
      self.ins_15_timeLeft = self.timeAdvance_Processor(self.ins_15_state)
      self.ins_15_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_16")
      self.ins_16_state = self.extTransition_Processor(self.ins_16_state, Y_inst, self.elapsed)
      self.ins_16_timeLeft = self.timeAdvance_Processor(self.ins_16_state)
      self.ins_16_elapsed = 0

    if(dStar == self.ins_16_state):
      self.Y = self.outputFnc_Processor(self.ins_16_state)
      self.ins_16_state = self.intTransition_Processor(self.ins_16_state)
      self.Y = self.renamePorts(self.Y, "ins_16")
      self.Y = self.mapConnections(self.Y)
      self.ins_16_timeLeft = self.timeAdvance_Processor(self.ins_16_state)
      self.ins_16_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_17")
      self.ins_17_state = self.extTransition_Processor(self.ins_17_state, Y_inst, self.elapsed)
      self.ins_17_timeLeft = self.timeAdvance_Processor(self.ins_17_state)
      self.ins_17_elapsed = 0

    if(dStar == self.ins_17_state):
      self.Y = self.outputFnc_Processor(self.ins_17_state)
      self.ins_17_state = self.intTransition_Processor(self.ins_17_state)
      self.Y = self.renamePorts(self.Y, "ins_17")
      self.Y = self.mapConnections(self.Y)
      self.ins_17_timeLeft = self.timeAdvance_Processor(self.ins_17_state)
      self.ins_17_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_18")
      self.ins_18_state = self.extTransition_Processor(self.ins_18_state, Y_inst, self.elapsed)
      self.ins_18_timeLeft = self.timeAdvance_Processor(self.ins_18_state)
      self.ins_18_elapsed = 0

    if(dStar == self.ins_18_state):
      self.Y = self.outputFnc_Processor(self.ins_18_state)
      self.ins_18_state = self.intTransition_Processor(self.ins_18_state)
      self.Y = self.renamePorts(self.Y, "ins_18")
      self.Y = self.mapConnections(self.Y)
      self.ins_18_timeLeft = self.timeAdvance_Processor(self.ins_18_state)
      self.ins_18_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_19")
      self.ins_19_state = self.extTransition_Processor(self.ins_19_state, Y_inst, self.elapsed)
      self.ins_19_timeLeft = self.timeAdvance_Processor(self.ins_19_state)
      self.ins_19_elapsed = 0

    if(dStar == self.ins_19_state):
      self.Y = self.outputFnc_Processor(self.ins_19_state)
      self.ins_19_state = self.intTransition_Processor(self.ins_19_state)
      self.Y = self.renamePorts(self.Y, "ins_19")
      self.Y = self.mapConnections(self.Y)
      self.ins_19_timeLeft = self.timeAdvance_Processor(self.ins_19_state)
      self.ins_19_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_20")
      self.ins_20_state = self.extTransition_Processor(self.ins_20_state, Y_inst, self.elapsed)
      self.ins_20_timeLeft = self.timeAdvance_Processor(self.ins_20_state)
      self.ins_20_elapsed = 0

    if(dStar == self.ins_20_state):
      self.Y = self.outputFnc_Processor(self.ins_20_state)
      self.ins_20_state = self.intTransition_Processor(self.ins_20_state)
      self.Y = self.renamePorts(self.Y, "ins_20")
      self.Y = self.mapConnections(self.Y)
      self.ins_20_timeLeft = self.timeAdvance_Processor(self.ins_20_state)
      self.ins_20_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_21")
      self.ins_21_state = self.extTransition_Processor(self.ins_21_state, Y_inst, self.elapsed)
      self.ins_21_timeLeft = self.timeAdvance_Processor(self.ins_21_state)
      self.ins_21_elapsed = 0

    if(dStar == self.ins_21_state):
      self.Y = self.outputFnc_Processor(self.ins_21_state)
      self.ins_21_state = self.intTransition_Processor(self.ins_21_state)
      self.Y = self.renamePorts(self.Y, "ins_21")
      self.Y = self.mapConnections(self.Y)
      self.ins_21_timeLeft = self.timeAdvance_Processor(self.ins_21_state)
      self.ins_21_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_22")
      self.ins_22_state = self.extTransition_Processor(self.ins_22_state, Y_inst, self.elapsed)
      self.ins_22_timeLeft = self.timeAdvance_Processor(self.ins_22_state)
      self.ins_22_elapsed = 0

    if(dStar == self.ins_22_state):
      self.Y = self.outputFnc_Processor(self.ins_22_state)
      self.ins_22_state = self.intTransition_Processor(self.ins_22_state)
      self.Y = self.renamePorts(self.Y, "ins_22")
      self.Y = self.mapConnections(self.Y)
      self.ins_22_timeLeft = self.timeAdvance_Processor(self.ins_22_state)
      self.ins_22_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_23")
      self.ins_23_state = self.extTransition_Processor(self.ins_23_state, Y_inst, self.elapsed)
      self.ins_23_timeLeft = self.timeAdvance_Processor(self.ins_23_state)
      self.ins_23_elapsed = 0

    if(dStar == self.ins_23_state):
      self.Y = self.outputFnc_Processor(self.ins_23_state)
      self.ins_23_state = self.intTransition_Processor(self.ins_23_state)
      self.Y = self.renamePorts(self.Y, "ins_23")
      self.Y = self.mapConnections(self.Y)
      self.ins_23_timeLeft = self.timeAdvance_Processor(self.ins_23_state)
      self.ins_23_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_24")
      self.ins_24_state = self.extTransition_Processor(self.ins_24_state, Y_inst, self.elapsed)
      self.ins_24_timeLeft = self.timeAdvance_Processor(self.ins_24_state)
      self.ins_24_elapsed = 0

    if(dStar == self.ins_24_state):
      self.Y = self.outputFnc_Processor(self.ins_24_state)
      self.ins_24_state = self.intTransition_Processor(self.ins_24_state)
      self.Y = self.renamePorts(self.Y, "ins_24")
      self.Y = self.mapConnections(self.Y)
      self.ins_24_timeLeft = self.timeAdvance_Processor(self.ins_24_state)
      self.ins_24_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_25")
      self.ins_25_state = self.extTransition_Processor(self.ins_25_state, Y_inst, self.elapsed)
      self.ins_25_timeLeft = self.timeAdvance_Processor(self.ins_25_state)
      self.ins_25_elapsed = 0

    if(dStar == self.ins_25_state):
      self.Y = self.outputFnc_Processor(self.ins_25_state)
      self.ins_25_state = self.intTransition_Processor(self.ins_25_state)
      self.Y = self.renamePorts(self.Y, "ins_25")
      self.Y = self.mapConnections(self.Y)
      self.ins_25_timeLeft = self.timeAdvance_Processor(self.ins_25_state)
      self.ins_25_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_26")
      self.ins_26_state = self.extTransition_Processor(self.ins_26_state, Y_inst, self.elapsed)
      self.ins_26_timeLeft = self.timeAdvance_Processor(self.ins_26_state)
      self.ins_26_elapsed = 0

    if(dStar == self.ins_26_state):
      self.Y = self.outputFnc_Processor(self.ins_26_state)
      self.ins_26_state = self.intTransition_Processor(self.ins_26_state)
      self.Y = self.renamePorts(self.Y, "ins_26")
      self.Y = self.mapConnections(self.Y)
      self.ins_26_timeLeft = self.timeAdvance_Processor(self.ins_26_state)
      self.ins_26_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_27")
      self.ins_27_state = self.extTransition_Processor(self.ins_27_state, Y_inst, self.elapsed)
      self.ins_27_timeLeft = self.timeAdvance_Processor(self.ins_27_state)
      self.ins_27_elapsed = 0

    if(dStar == self.ins_27_state):
      self.Y = self.outputFnc_Processor(self.ins_27_state)
      self.ins_27_state = self.intTransition_Processor(self.ins_27_state)
      self.Y = self.renamePorts(self.Y, "ins_27")
      self.Y = self.mapConnections(self.Y)
      self.ins_27_timeLeft = self.timeAdvance_Processor(self.ins_27_state)
      self.ins_27_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_28")
      self.ins_28_state = self.extTransition_Processor(self.ins_28_state, Y_inst, self.elapsed)
      self.ins_28_timeLeft = self.timeAdvance_Processor(self.ins_28_state)
      self.ins_28_elapsed = 0

    if(dStar == self.ins_28_state):
      self.Y = self.outputFnc_Processor(self.ins_28_state)
      self.ins_28_state = self.intTransition_Processor(self.ins_28_state)
      self.Y = self.renamePorts(self.Y, "ins_28")
      self.Y = self.mapConnections(self.Y)
      self.ins_28_timeLeft = self.timeAdvance_Processor(self.ins_28_state)
      self.ins_28_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_29")
      self.ins_29_state = self.extTransition_Processor(self.ins_29_state, Y_inst, self.elapsed)
      self.ins_29_timeLeft = self.timeAdvance_Processor(self.ins_29_state)
      self.ins_29_elapsed = 0

    if(dStar == self.ins_29_state):
      self.Y = self.outputFnc_Processor(self.ins_29_state)
      self.ins_29_state = self.intTransition_Processor(self.ins_29_state)
      self.Y = self.renamePorts(self.Y, "ins_29")
      self.Y = self.mapConnections(self.Y)
      self.ins_29_timeLeft = self.timeAdvance_Processor(self.ins_29_state)
      self.ins_29_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_30")
      self.ins_30_state = self.extTransition_Processor(self.ins_30_state, Y_inst, self.elapsed)
      self.ins_30_timeLeft = self.timeAdvance_Processor(self.ins_30_state)
      self.ins_30_elapsed = 0

    if(dStar == self.ins_30_state):
      self.Y = self.outputFnc_Processor(self.ins_30_state)
      self.ins_30_state = self.intTransition_Processor(self.ins_30_state)
      self.Y = self.renamePorts(self.Y, "ins_30")
      self.Y = self.mapConnections(self.Y)
      self.ins_30_timeLeft = self.timeAdvance_Processor(self.ins_30_state)
      self.ins_30_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_31")
      self.ins_31_state = self.extTransition_Processor(self.ins_31_state, Y_inst, self.elapsed)
      self.ins_31_timeLeft = self.timeAdvance_Processor(self.ins_31_state)
      self.ins_31_elapsed = 0

    if(dStar == self.ins_31_state):
      self.Y = self.outputFnc_Processor(self.ins_31_state)
      self.ins_31_state = self.intTransition_Processor(self.ins_31_state)
      self.Y = self.renamePorts(self.Y, "ins_31")
      self.Y = self.mapConnections(self.Y)
      self.ins_31_timeLeft = self.timeAdvance_Processor(self.ins_31_state)
      self.ins_31_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_32")
      self.ins_32_state = self.extTransition_Processor(self.ins_32_state, Y_inst, self.elapsed)
      self.ins_32_timeLeft = self.timeAdvance_Processor(self.ins_32_state)
      self.ins_32_elapsed = 0

    if(dStar == self.ins_32_state):
      self.Y = self.outputFnc_Processor(self.ins_32_state)
      self.ins_32_state = self.intTransition_Processor(self.ins_32_state)
      self.Y = self.renamePorts(self.Y, "ins_32")
      self.Y = self.mapConnections(self.Y)
      self.ins_32_timeLeft = self.timeAdvance_Processor(self.ins_32_state)
      self.ins_32_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_33")
      self.ins_33_state = self.extTransition_Processor(self.ins_33_state, Y_inst, self.elapsed)
      self.ins_33_timeLeft = self.timeAdvance_Processor(self.ins_33_state)
      self.ins_33_elapsed = 0

    if(dStar == self.ins_33_state):
      self.Y = self.outputFnc_Processor(self.ins_33_state)
      self.ins_33_state = self.intTransition_Processor(self.ins_33_state)
      self.Y = self.renamePorts(self.Y, "ins_33")
      self.Y = self.mapConnections(self.Y)
      self.ins_33_timeLeft = self.timeAdvance_Processor(self.ins_33_state)
      self.ins_33_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_34")
      self.ins_34_state = self.extTransition_Processor(self.ins_34_state, Y_inst, self.elapsed)
      self.ins_34_timeLeft = self.timeAdvance_Processor(self.ins_34_state)
      self.ins_34_elapsed = 0

    if(dStar == self.ins_34_state):
      self.Y = self.outputFnc_Processor(self.ins_34_state)
      self.ins_34_state = self.intTransition_Processor(self.ins_34_state)
      self.Y = self.renamePorts(self.Y, "ins_34")
      self.Y = self.mapConnections(self.Y)
      self.ins_34_timeLeft = self.timeAdvance_Processor(self.ins_34_state)
      self.ins_34_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_35")
      self.ins_35_state = self.extTransition_Processor(self.ins_35_state, Y_inst, self.elapsed)
      self.ins_35_timeLeft = self.timeAdvance_Processor(self.ins_35_state)
      self.ins_35_elapsed = 0

    if(dStar == self.ins_35_state):
      self.Y = self.outputFnc_Processor(self.ins_35_state)
      self.ins_35_state = self.intTransition_Processor(self.ins_35_state)
      self.Y = self.renamePorts(self.Y, "ins_35")
      self.Y = self.mapConnections(self.Y)
      self.ins_35_timeLeft = self.timeAdvance_Processor(self.ins_35_state)
      self.ins_35_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_36")
      self.ins_36_state = self.extTransition_Processor(self.ins_36_state, Y_inst, self.elapsed)
      self.ins_36_timeLeft = self.timeAdvance_Processor(self.ins_36_state)
      self.ins_36_elapsed = 0

    if(dStar == self.ins_36_state):
      self.Y = self.outputFnc_Processor(self.ins_36_state)
      self.ins_36_state = self.intTransition_Processor(self.ins_36_state)
      self.Y = self.renamePorts(self.Y, "ins_36")
      self.Y = self.mapConnections(self.Y)
      self.ins_36_timeLeft = self.timeAdvance_Processor(self.ins_36_state)
      self.ins_36_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_37")
      self.ins_37_state = self.extTransition_Processor(self.ins_37_state, Y_inst, self.elapsed)
      self.ins_37_timeLeft = self.timeAdvance_Processor(self.ins_37_state)
      self.ins_37_elapsed = 0

    if(dStar == self.ins_37_state):
      self.Y = self.outputFnc_Processor(self.ins_37_state)
      self.ins_37_state = self.intTransition_Processor(self.ins_37_state)
      self.Y = self.renamePorts(self.Y, "ins_37")
      self.Y = self.mapConnections(self.Y)
      self.ins_37_timeLeft = self.timeAdvance_Processor(self.ins_37_state)
      self.ins_37_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_38")
      self.ins_38_state = self.extTransition_Processor(self.ins_38_state, Y_inst, self.elapsed)
      self.ins_38_timeLeft = self.timeAdvance_Processor(self.ins_38_state)
      self.ins_38_elapsed = 0

    if(dStar == self.ins_38_state):
      self.Y = self.outputFnc_Processor(self.ins_38_state)
      self.ins_38_state = self.intTransition_Processor(self.ins_38_state)
      self.Y = self.renamePorts(self.Y, "ins_38")
      self.Y = self.mapConnections(self.Y)
      self.ins_38_timeLeft = self.timeAdvance_Processor(self.ins_38_state)
      self.ins_38_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_39")
      self.ins_39_state = self.extTransition_Processor(self.ins_39_state, Y_inst, self.elapsed)
      self.ins_39_timeLeft = self.timeAdvance_Processor(self.ins_39_state)
      self.ins_39_elapsed = 0

    if(dStar == self.ins_39_state):
      self.Y = self.outputFnc_Processor(self.ins_39_state)
      self.ins_39_state = self.intTransition_Processor(self.ins_39_state)
      self.Y = self.renamePorts(self.Y, "ins_39")
      self.Y = self.mapConnections(self.Y)
      self.ins_39_timeLeft = self.timeAdvance_Processor(self.ins_39_state)
      self.ins_39_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_40")
      self.ins_40_state = self.extTransition_Processor(self.ins_40_state, Y_inst, self.elapsed)
      self.ins_40_timeLeft = self.timeAdvance_Processor(self.ins_40_state)
      self.ins_40_elapsed = 0

    if(dStar == self.ins_40_state):
      self.Y = self.outputFnc_Processor(self.ins_40_state)
      self.ins_40_state = self.intTransition_Processor(self.ins_40_state)
      self.Y = self.renamePorts(self.Y, "ins_40")
      self.Y = self.mapConnections(self.Y)
      self.ins_40_timeLeft = self.timeAdvance_Processor(self.ins_40_state)
      self.ins_40_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_41")
      self.ins_41_state = self.extTransition_Processor(self.ins_41_state, Y_inst, self.elapsed)
      self.ins_41_timeLeft = self.timeAdvance_Processor(self.ins_41_state)
      self.ins_41_elapsed = 0

    if(dStar == self.ins_41_state):
      self.Y = self.outputFnc_Processor(self.ins_41_state)
      self.ins_41_state = self.intTransition_Processor(self.ins_41_state)
      self.Y = self.renamePorts(self.Y, "ins_41")
      self.Y = self.mapConnections(self.Y)
      self.ins_41_timeLeft = self.timeAdvance_Processor(self.ins_41_state)
      self.ins_41_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_42")
      self.ins_42_state = self.extTransition_Processor(self.ins_42_state, Y_inst, self.elapsed)
      self.ins_42_timeLeft = self.timeAdvance_Processor(self.ins_42_state)
      self.ins_42_elapsed = 0

    if(dStar == self.ins_42_state):
      self.Y = self.outputFnc_Processor(self.ins_42_state)
      self.ins_42_state = self.intTransition_Processor(self.ins_42_state)
      self.Y = self.renamePorts(self.Y, "ins_42")
      self.Y = self.mapConnections(self.Y)
      self.ins_42_timeLeft = self.timeAdvance_Processor(self.ins_42_state)
      self.ins_42_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_43")
      self.ins_43_state = self.extTransition_Processor(self.ins_43_state, Y_inst, self.elapsed)
      self.ins_43_timeLeft = self.timeAdvance_Processor(self.ins_43_state)
      self.ins_43_elapsed = 0

    if(dStar == self.ins_43_state):
      self.Y = self.outputFnc_Processor(self.ins_43_state)
      self.ins_43_state = self.intTransition_Processor(self.ins_43_state)
      self.Y = self.renamePorts(self.Y, "ins_43")
      self.Y = self.mapConnections(self.Y)
      self.ins_43_timeLeft = self.timeAdvance_Processor(self.ins_43_state)
      self.ins_43_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_44")
      self.ins_44_state = self.extTransition_Processor(self.ins_44_state, Y_inst, self.elapsed)
      self.ins_44_timeLeft = self.timeAdvance_Processor(self.ins_44_state)
      self.ins_44_elapsed = 0

    if(dStar == self.ins_44_state):
      self.Y = self.outputFnc_Processor(self.ins_44_state)
      self.ins_44_state = self.intTransition_Processor(self.ins_44_state)
      self.Y = self.renamePorts(self.Y, "ins_44")
      self.Y = self.mapConnections(self.Y)
      self.ins_44_timeLeft = self.timeAdvance_Processor(self.ins_44_state)
      self.ins_44_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_45")
      self.ins_45_state = self.extTransition_Processor(self.ins_45_state, Y_inst, self.elapsed)
      self.ins_45_timeLeft = self.timeAdvance_Processor(self.ins_45_state)
      self.ins_45_elapsed = 0

    if(dStar == self.ins_45_state):
      self.Y = self.outputFnc_Processor(self.ins_45_state)
      self.ins_45_state = self.intTransition_Processor(self.ins_45_state)
      self.Y = self.renamePorts(self.Y, "ins_45")
      self.Y = self.mapConnections(self.Y)
      self.ins_45_timeLeft = self.timeAdvance_Processor(self.ins_45_state)
      self.ins_45_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_46")
      self.ins_46_state = self.extTransition_Processor(self.ins_46_state, Y_inst, self.elapsed)
      self.ins_46_timeLeft = self.timeAdvance_Processor(self.ins_46_state)
      self.ins_46_elapsed = 0

    if(dStar == self.ins_46_state):
      self.Y = self.outputFnc_Processor(self.ins_46_state)
      self.ins_46_state = self.intTransition_Processor(self.ins_46_state)
      self.Y = self.renamePorts(self.Y, "ins_46")
      self.Y = self.mapConnections(self.Y)
      self.ins_46_timeLeft = self.timeAdvance_Processor(self.ins_46_state)
      self.ins_46_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_47")
      self.ins_47_state = self.extTransition_Processor(self.ins_47_state, Y_inst, self.elapsed)
      self.ins_47_timeLeft = self.timeAdvance_Processor(self.ins_47_state)
      self.ins_47_elapsed = 0

    if(dStar == self.ins_47_state):
      self.Y = self.outputFnc_Processor(self.ins_47_state)
      self.ins_47_state = self.intTransition_Processor(self.ins_47_state)
      self.Y = self.renamePorts(self.Y, "ins_47")
      self.Y = self.mapConnections(self.Y)
      self.ins_47_timeLeft = self.timeAdvance_Processor(self.ins_47_state)
      self.ins_47_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_48")
      self.ins_48_state = self.extTransition_Processor(self.ins_48_state, Y_inst, self.elapsed)
      self.ins_48_timeLeft = self.timeAdvance_Processor(self.ins_48_state)
      self.ins_48_elapsed = 0

    if(dStar == self.ins_48_state):
      self.Y = self.outputFnc_Processor(self.ins_48_state)
      self.ins_48_state = self.intTransition_Processor(self.ins_48_state)
      self.Y = self.renamePorts(self.Y, "ins_48")
      self.Y = self.mapConnections(self.Y)
      self.ins_48_timeLeft = self.timeAdvance_Processor(self.ins_48_state)
      self.ins_48_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_49")
      self.ins_49_state = self.extTransition_Processor(self.ins_49_state, Y_inst, self.elapsed)
      self.ins_49_timeLeft = self.timeAdvance_Processor(self.ins_49_state)
      self.ins_49_elapsed = 0

    if(dStar == self.ins_49_state):
      self.Y = self.outputFnc_Processor(self.ins_49_state)
      self.ins_49_state = self.intTransition_Processor(self.ins_49_state)
      self.Y = self.renamePorts(self.Y, "ins_49")
      self.Y = self.mapConnections(self.Y)
      self.ins_49_timeLeft = self.timeAdvance_Processor(self.ins_49_state)
      self.ins_49_elapsed = 0
      Y_inst = self.getInstances(self.Y, "ins_50")
      self.ins_50_state = self.extTransition_Processor(self.ins_50_state, Y_inst, self.elapsed)
      self.ins_50_timeLeft = self.timeAdvance_Processor(self.ins_50_state)
      self.ins_50_elapsed = 0

    if(dStar == self.ins_50_state):
      self.Y = self.outputFnc_Processor(self.ins_50_state)
      self.ins_50_state = self.intTransition_Processor(self.ins_50_state)
      self.Y = self.renamePorts(self.Y, "ins_50")
      self.Y = self.mapConnections(self.Y)
      self.ins_50_timeLeft = self.timeAdvance_Processor(self.ins_50_state)
      self.ins_50_elapsed = 0
    return self.state

  
  def select( self, immChildren ):
    child = immChildren[0]
    return child

  
  def extTransition( self ):
    Y = dict()
    X = dict()
    keys = list()
    Y_inst = dict()
    self.ins_0_timeLeft = self.ins_0_timeLeft - self.elapsed

    self.ins_1_timeLeft = self.ins_1_timeLeft - self.elapsed

    self.ins_2_timeLeft = self.ins_2_timeLeft - self.elapsed

    self.ins_3_timeLeft = self.ins_3_timeLeft - self.elapsed

    self.ins_4_timeLeft = self.ins_4_timeLeft - self.elapsed

    self.ins_5_timeLeft = self.ins_5_timeLeft - self.elapsed

    self.ins_6_timeLeft = self.ins_6_timeLeft - self.elapsed

    self.ins_7_timeLeft = self.ins_7_timeLeft - self.elapsed

    self.ins_8_timeLeft = self.ins_8_timeLeft - self.elapsed

    self.ins_9_timeLeft = self.ins_9_timeLeft - self.elapsed

    self.ins_10_timeLeft = self.ins_10_timeLeft - self.elapsed

    self.ins_11_timeLeft = self.ins_11_timeLeft - self.elapsed

    self.ins_12_timeLeft = self.ins_12_timeLeft - self.elapsed

    self.ins_13_timeLeft = self.ins_13_timeLeft - self.elapsed

    self.ins_14_timeLeft = self.ins_14_timeLeft - self.elapsed

    self.ins_15_timeLeft = self.ins_15_timeLeft - self.elapsed

    self.ins_16_timeLeft = self.ins_16_timeLeft - self.elapsed

    self.ins_17_timeLeft = self.ins_17_timeLeft - self.elapsed

    self.ins_18_timeLeft = self.ins_18_timeLeft - self.elapsed

    self.ins_19_timeLeft = self.ins_19_timeLeft - self.elapsed

    self.ins_20_timeLeft = self.ins_20_timeLeft - self.elapsed

    self.ins_21_timeLeft = self.ins_21_timeLeft - self.elapsed

    self.ins_22_timeLeft = self.ins_22_timeLeft - self.elapsed

    self.ins_23_timeLeft = self.ins_23_timeLeft - self.elapsed

    self.ins_24_timeLeft = self.ins_24_timeLeft - self.elapsed

    self.ins_25_timeLeft = self.ins_25_timeLeft - self.elapsed

    self.ins_26_timeLeft = self.ins_26_timeLeft - self.elapsed

    self.ins_27_timeLeft = self.ins_27_timeLeft - self.elapsed

    self.ins_28_timeLeft = self.ins_28_timeLeft - self.elapsed

    self.ins_29_timeLeft = self.ins_29_timeLeft - self.elapsed

    self.ins_30_timeLeft = self.ins_30_timeLeft - self.elapsed

    self.ins_31_timeLeft = self.ins_31_timeLeft - self.elapsed

    self.ins_32_timeLeft = self.ins_32_timeLeft - self.elapsed

    self.ins_33_timeLeft = self.ins_33_timeLeft - self.elapsed

    self.ins_34_timeLeft = self.ins_34_timeLeft - self.elapsed

    self.ins_35_timeLeft = self.ins_35_timeLeft - self.elapsed

    self.ins_36_timeLeft = self.ins_36_timeLeft - self.elapsed

    self.ins_37_timeLeft = self.ins_37_timeLeft - self.elapsed

    self.ins_38_timeLeft = self.ins_38_timeLeft - self.elapsed

    self.ins_39_timeLeft = self.ins_39_timeLeft - self.elapsed

    self.ins_40_timeLeft = self.ins_40_timeLeft - self.elapsed

    self.ins_41_timeLeft = self.ins_41_timeLeft - self.elapsed

    self.ins_42_timeLeft = self.ins_42_timeLeft - self.elapsed

    self.ins_43_timeLeft = self.ins_43_timeLeft - self.elapsed

    self.ins_44_timeLeft = self.ins_44_timeLeft - self.elapsed

    self.ins_45_timeLeft = self.ins_45_timeLeft - self.elapsed

    self.ins_46_timeLeft = self.ins_46_timeLeft - self.elapsed

    self.ins_47_timeLeft = self.ins_47_timeLeft - self.elapsed

    self.ins_48_timeLeft = self.ins_48_timeLeft - self.elapsed

    self.ins_49_timeLeft = self.ins_49_timeLeft - self.elapsed

    self.ins_50_timeLeft = self.ins_50_timeLeft - self.elapsed

    self.ins_0_elapsed = self.ins_0_elapsed + self.elapsed

    self.ins_1_elapsed = self.ins_1_elapsed + self.elapsed

    self.ins_2_elapsed = self.ins_2_elapsed + self.elapsed

    self.ins_3_elapsed = self.ins_3_elapsed + self.elapsed

    self.ins_4_elapsed = self.ins_4_elapsed + self.elapsed

    self.ins_5_elapsed = self.ins_5_elapsed + self.elapsed

    self.ins_6_elapsed = self.ins_6_elapsed + self.elapsed

    self.ins_7_elapsed = self.ins_7_elapsed + self.elapsed

    self.ins_8_elapsed = self.ins_8_elapsed + self.elapsed

    self.ins_9_elapsed = self.ins_9_elapsed + self.elapsed

    self.ins_10_elapsed = self.ins_10_elapsed + self.elapsed

    self.ins_11_elapsed = self.ins_11_elapsed + self.elapsed

    self.ins_12_elapsed = self.ins_12_elapsed + self.elapsed

    self.ins_13_elapsed = self.ins_13_elapsed + self.elapsed

    self.ins_14_elapsed = self.ins_14_elapsed + self.elapsed

    self.ins_15_elapsed = self.ins_15_elapsed + self.elapsed

    self.ins_16_elapsed = self.ins_16_elapsed + self.elapsed

    self.ins_17_elapsed = self.ins_17_elapsed + self.elapsed

    self.ins_18_elapsed = self.ins_18_elapsed + self.elapsed

    self.ins_19_elapsed = self.ins_19_elapsed + self.elapsed

    self.ins_20_elapsed = self.ins_20_elapsed + self.elapsed

    self.ins_21_elapsed = self.ins_21_elapsed + self.elapsed

    self.ins_22_elapsed = self.ins_22_elapsed + self.elapsed

    self.ins_23_elapsed = self.ins_23_elapsed + self.elapsed

    self.ins_24_elapsed = self.ins_24_elapsed + self.elapsed

    self.ins_25_elapsed = self.ins_25_elapsed + self.elapsed

    self.ins_26_elapsed = self.ins_26_elapsed + self.elapsed

    self.ins_27_elapsed = self.ins_27_elapsed + self.elapsed

    self.ins_28_elapsed = self.ins_28_elapsed + self.elapsed

    self.ins_29_elapsed = self.ins_29_elapsed + self.elapsed

    self.ins_30_elapsed = self.ins_30_elapsed + self.elapsed

    self.ins_31_elapsed = self.ins_31_elapsed + self.elapsed

    self.ins_32_elapsed = self.ins_32_elapsed + self.elapsed

    self.ins_33_elapsed = self.ins_33_elapsed + self.elapsed

    self.ins_34_elapsed = self.ins_34_elapsed + self.elapsed

    self.ins_35_elapsed = self.ins_35_elapsed + self.elapsed

    self.ins_36_elapsed = self.ins_36_elapsed + self.elapsed

    self.ins_37_elapsed = self.ins_37_elapsed + self.elapsed

    self.ins_38_elapsed = self.ins_38_elapsed + self.elapsed

    self.ins_39_elapsed = self.ins_39_elapsed + self.elapsed

    self.ins_40_elapsed = self.ins_40_elapsed + self.elapsed

    self.ins_41_elapsed = self.ins_41_elapsed + self.elapsed

    self.ins_42_elapsed = self.ins_42_elapsed + self.elapsed

    self.ins_43_elapsed = self.ins_43_elapsed + self.elapsed

    self.ins_44_elapsed = self.ins_44_elapsed + self.elapsed

    self.ins_45_elapsed = self.ins_45_elapsed + self.elapsed

    self.ins_46_elapsed = self.ins_46_elapsed + self.elapsed

    self.ins_47_elapsed = self.ins_47_elapsed + self.elapsed

    self.ins_48_elapsed = self.ins_48_elapsed + self.elapsed

    self.ins_49_elapsed = self.ins_49_elapsed + self.elapsed

    self.ins_50_elapsed = self.ins_50_elapsed + self.elapsed

    Y = self.mapConnections(X)

    keys = self.getModelKeys(Y)

    if(keys.__contains__("ins_0")):
      Y_inst = self.getInstances(Y, "ins_0")
      self.ins_0_state = extTransition_Generator(self.ins_0_state, Y_inst, self.ins_0_elapsed)
      self.ins_0_timeLeft = self.timeAdvance_Generator(self.ins_0_state)
      self.ins_0_elapsed = 0

    if(keys.__contains__("ins_1")):
      Y_inst = self.getInstances(Y, "ins_1")
      self.ins_1_state = self.extTransition_Processor(self.ins_1_state, Y_inst, self.ins_1_elapsed)
      self.ins_1_timeLeft = self.timeAdvance_Processor(self.ins_1_state)
      self.ins_1_elapsed = 0

    if(keys.__contains__("ins_2")):
      Y_inst = self.getInstances(Y, "ins_2")
      self.ins_2_state = self.extTransition_Processor(self.ins_2_state, Y_inst, self.ins_2_elapsed)
      self.ins_2_timeLeft = self.timeAdvance_Processor(self.ins_2_state)
      self.ins_2_elapsed = 0

    if(keys.__contains__("ins_3")):
      Y_inst = self.getInstances(Y, "ins_3")
      self.ins_3_state = self.extTransition_Processor(self.ins_3_state, Y_inst, self.ins_3_elapsed)
      self.ins_3_timeLeft = self.timeAdvance_Processor(self.ins_3_state)
      self.ins_3_elapsed = 0

    if(keys.__contains__("ins_4")):
      Y_inst = self.getInstances(Y, "ins_4")
      self.ins_4_state = self.extTransition_Processor(self.ins_4_state, Y_inst, self.ins_4_elapsed)
      self.ins_4_timeLeft = self.timeAdvance_Processor(self.ins_4_state)
      self.ins_4_elapsed = 0

    if(keys.__contains__("ins_5")):
      Y_inst = self.getInstances(Y, "ins_5")
      self.ins_5_state = self.extTransition_Processor(self.ins_5_state, Y_inst, self.ins_5_elapsed)
      self.ins_5_timeLeft = self.timeAdvance_Processor(self.ins_5_state)
      self.ins_5_elapsed = 0

    if(keys.__contains__("ins_6")):
      Y_inst = self.getInstances(Y, "ins_6")
      self.ins_6_state = self.extTransition_Processor(self.ins_6_state, Y_inst, self.ins_6_elapsed)
      self.ins_6_timeLeft = self.timeAdvance_Processor(self.ins_6_state)
      self.ins_6_elapsed = 0

    if(keys.__contains__("ins_7")):
      Y_inst = self.getInstances(Y, "ins_7")
      self.ins_7_state = self.extTransition_Processor(self.ins_7_state, Y_inst, self.ins_7_elapsed)
      self.ins_7_timeLeft = self.timeAdvance_Processor(self.ins_7_state)
      self.ins_7_elapsed = 0

    if(keys.__contains__("ins_8")):
      Y_inst = self.getInstances(Y, "ins_8")
      self.ins_8_state = self.extTransition_Processor(self.ins_8_state, Y_inst, self.ins_8_elapsed)
      self.ins_8_timeLeft = self.timeAdvance_Processor(self.ins_8_state)
      self.ins_8_elapsed = 0

    if(keys.__contains__("ins_9")):
      Y_inst = self.getInstances(Y, "ins_9")
      self.ins_9_state = self.extTransition_Processor(self.ins_9_state, Y_inst, self.ins_9_elapsed)
      self.ins_9_timeLeft = self.timeAdvance_Processor(self.ins_9_state)
      self.ins_9_elapsed = 0

    if(keys.__contains__("ins_10")):
      Y_inst = self.getInstances(Y, "ins_10")
      self.ins_10_state = self.extTransition_Processor(self.ins_10_state, Y_inst, self.ins_10_elapsed)
      self.ins_10_timeLeft = self.timeAdvance_Processor(self.ins_10_state)
      self.ins_10_elapsed = 0

    if(keys.__contains__("ins_11")):
      Y_inst = self.getInstances(Y, "ins_11")
      self.ins_11_state = self.extTransition_Processor(self.ins_11_state, Y_inst, self.ins_11_elapsed)
      self.ins_11_timeLeft = self.timeAdvance_Processor(self.ins_11_state)
      self.ins_11_elapsed = 0

    if(keys.__contains__("ins_12")):
      Y_inst = self.getInstances(Y, "ins_12")
      self.ins_12_state = self.extTransition_Processor(self.ins_12_state, Y_inst, self.ins_12_elapsed)
      self.ins_12_timeLeft = self.timeAdvance_Processor(self.ins_12_state)
      self.ins_12_elapsed = 0

    if(keys.__contains__("ins_13")):
      Y_inst = self.getInstances(Y, "ins_13")
      self.ins_13_state = self.extTransition_Processor(self.ins_13_state, Y_inst, self.ins_13_elapsed)
      self.ins_13_timeLeft = self.timeAdvance_Processor(self.ins_13_state)
      self.ins_13_elapsed = 0

    if(keys.__contains__("ins_14")):
      Y_inst = self.getInstances(Y, "ins_14")
      self.ins_14_state = self.extTransition_Processor(self.ins_14_state, Y_inst, self.ins_14_elapsed)
      self.ins_14_timeLeft = self.timeAdvance_Processor(self.ins_14_state)
      self.ins_14_elapsed = 0

    if(keys.__contains__("ins_15")):
      Y_inst = self.getInstances(Y, "ins_15")
      self.ins_15_state = self.extTransition_Processor(self.ins_15_state, Y_inst, self.ins_15_elapsed)
      self.ins_15_timeLeft = self.timeAdvance_Processor(self.ins_15_state)
      self.ins_15_elapsed = 0

    if(keys.__contains__("ins_16")):
      Y_inst = self.getInstances(Y, "ins_16")
      self.ins_16_state = self.extTransition_Processor(self.ins_16_state, Y_inst, self.ins_16_elapsed)
      self.ins_16_timeLeft = self.timeAdvance_Processor(self.ins_16_state)
      self.ins_16_elapsed = 0

    if(keys.__contains__("ins_17")):
      Y_inst = self.getInstances(Y, "ins_17")
      self.ins_17_state = self.extTransition_Processor(self.ins_17_state, Y_inst, self.ins_17_elapsed)
      self.ins_17_timeLeft = self.timeAdvance_Processor(self.ins_17_state)
      self.ins_17_elapsed = 0

    if(keys.__contains__("ins_18")):
      Y_inst = self.getInstances(Y, "ins_18")
      self.ins_18_state = self.extTransition_Processor(self.ins_18_state, Y_inst, self.ins_18_elapsed)
      self.ins_18_timeLeft = self.timeAdvance_Processor(self.ins_18_state)
      self.ins_18_elapsed = 0

    if(keys.__contains__("ins_19")):
      Y_inst = self.getInstances(Y, "ins_19")
      self.ins_19_state = self.extTransition_Processor(self.ins_19_state, Y_inst, self.ins_19_elapsed)
      self.ins_19_timeLeft = self.timeAdvance_Processor(self.ins_19_state)
      self.ins_19_elapsed = 0

    if(keys.__contains__("ins_20")):
      Y_inst = self.getInstances(Y, "ins_20")
      self.ins_20_state = self.extTransition_Processor(self.ins_20_state, Y_inst, self.ins_20_elapsed)
      self.ins_20_timeLeft = self.timeAdvance_Processor(self.ins_20_state)
      self.ins_20_elapsed = 0

    if(keys.__contains__("ins_21")):
      Y_inst = self.getInstances(Y, "ins_21")
      self.ins_21_state = self.extTransition_Processor(self.ins_21_state, Y_inst, self.ins_21_elapsed)
      self.ins_21_timeLeft = self.timeAdvance_Processor(self.ins_21_state)
      self.ins_21_elapsed = 0

    if(keys.__contains__("ins_22")):
      Y_inst = self.getInstances(Y, "ins_22")
      self.ins_22_state = self.extTransition_Processor(self.ins_22_state, Y_inst, self.ins_22_elapsed)
      self.ins_22_timeLeft = self.timeAdvance_Processor(self.ins_22_state)
      self.ins_22_elapsed = 0

    if(keys.__contains__("ins_23")):
      Y_inst = self.getInstances(Y, "ins_23")
      self.ins_23_state = self.extTransition_Processor(self.ins_23_state, Y_inst, self.ins_23_elapsed)
      self.ins_23_timeLeft = self.timeAdvance_Processor(self.ins_23_state)
      self.ins_23_elapsed = 0

    if(keys.__contains__("ins_24")):
      Y_inst = self.getInstances(Y, "ins_24")
      self.ins_24_state = self.extTransition_Processor(self.ins_24_state, Y_inst, self.ins_24_elapsed)
      self.ins_24_timeLeft = self.timeAdvance_Processor(self.ins_24_state)
      self.ins_24_elapsed = 0

    if(keys.__contains__("ins_25")):
      Y_inst = self.getInstances(Y, "ins_25")
      self.ins_25_state = self.extTransition_Processor(self.ins_25_state, Y_inst, self.ins_25_elapsed)
      self.ins_25_timeLeft = self.timeAdvance_Processor(self.ins_25_state)
      self.ins_25_elapsed = 0

    if(keys.__contains__("ins_26")):
      Y_inst = self.getInstances(Y, "ins_26")
      self.ins_26_state = self.extTransition_Processor(self.ins_26_state, Y_inst, self.ins_26_elapsed)
      self.ins_26_timeLeft = self.timeAdvance_Processor(self.ins_26_state)
      self.ins_26_elapsed = 0

    if(keys.__contains__("ins_27")):
      Y_inst = self.getInstances(Y, "ins_27")
      self.ins_27_state = self.extTransition_Processor(self.ins_27_state, Y_inst, self.ins_27_elapsed)
      self.ins_27_timeLeft = self.timeAdvance_Processor(self.ins_27_state)
      self.ins_27_elapsed = 0

    if(keys.__contains__("ins_28")):
      Y_inst = self.getInstances(Y, "ins_28")
      self.ins_28_state = self.extTransition_Processor(self.ins_28_state, Y_inst, self.ins_28_elapsed)
      self.ins_28_timeLeft = self.timeAdvance_Processor(self.ins_28_state)
      self.ins_28_elapsed = 0

    if(keys.__contains__("ins_29")):
      Y_inst = self.getInstances(Y, "ins_29")
      self.ins_29_state = self.extTransition_Processor(self.ins_29_state, Y_inst, self.ins_29_elapsed)
      self.ins_29_timeLeft = self.timeAdvance_Processor(self.ins_29_state)
      self.ins_29_elapsed = 0

    if(keys.__contains__("ins_30")):
      Y_inst = self.getInstances(Y, "ins_30")
      self.ins_30_state = self.extTransition_Processor(self.ins_30_state, Y_inst, self.ins_30_elapsed)
      self.ins_30_timeLeft = self.timeAdvance_Processor(self.ins_30_state)
      self.ins_30_elapsed = 0

    if(keys.__contains__("ins_31")):
      Y_inst = self.getInstances(Y, "ins_31")
      self.ins_31_state = self.extTransition_Processor(self.ins_31_state, Y_inst, self.ins_31_elapsed)
      self.ins_31_timeLeft = self.timeAdvance_Processor(self.ins_31_state)
      self.ins_31_elapsed = 0

    if(keys.__contains__("ins_32")):
      Y_inst = self.getInstances(Y, "ins_32")
      self.ins_32_state = self.extTransition_Processor(self.ins_32_state, Y_inst, self.ins_32_elapsed)
      self.ins_32_timeLeft = self.timeAdvance_Processor(self.ins_32_state)
      self.ins_32_elapsed = 0

    if(keys.__contains__("ins_33")):
      Y_inst = self.getInstances(Y, "ins_33")
      self.ins_33_state = self.extTransition_Processor(self.ins_33_state, Y_inst, self.ins_33_elapsed)
      self.ins_33_timeLeft = self.timeAdvance_Processor(self.ins_33_state)
      self.ins_33_elapsed = 0

    if(keys.__contains__("ins_34")):
      Y_inst = self.getInstances(Y, "ins_34")
      self.ins_34_state = self.extTransition_Processor(self.ins_34_state, Y_inst, self.ins_34_elapsed)
      self.ins_34_timeLeft = self.timeAdvance_Processor(self.ins_34_state)
      self.ins_34_elapsed = 0

    if(keys.__contains__("ins_35")):
      Y_inst = self.getInstances(Y, "ins_35")
      self.ins_35_state = self.extTransition_Processor(self.ins_35_state, Y_inst, self.ins_35_elapsed)
      self.ins_35_timeLeft = self.timeAdvance_Processor(self.ins_35_state)
      self.ins_35_elapsed = 0

    if(keys.__contains__("ins_36")):
      Y_inst = self.getInstances(Y, "ins_36")
      self.ins_36_state = self.extTransition_Processor(self.ins_36_state, Y_inst, self.ins_36_elapsed)
      self.ins_36_timeLeft = self.timeAdvance_Processor(self.ins_36_state)
      self.ins_36_elapsed = 0

    if(keys.__contains__("ins_37")):
      Y_inst = self.getInstances(Y, "ins_37")
      self.ins_37_state = self.extTransition_Processor(self.ins_37_state, Y_inst, self.ins_37_elapsed)
      self.ins_37_timeLeft = self.timeAdvance_Processor(self.ins_37_state)
      self.ins_37_elapsed = 0

    if(keys.__contains__("ins_38")):
      Y_inst = self.getInstances(Y, "ins_38")
      self.ins_38_state = self.extTransition_Processor(self.ins_38_state, Y_inst, self.ins_38_elapsed)
      self.ins_38_timeLeft = self.timeAdvance_Processor(self.ins_38_state)
      self.ins_38_elapsed = 0

    if(keys.__contains__("ins_39")):
      Y_inst = self.getInstances(Y, "ins_39")
      self.ins_39_state = self.extTransition_Processor(self.ins_39_state, Y_inst, self.ins_39_elapsed)
      self.ins_39_timeLeft = self.timeAdvance_Processor(self.ins_39_state)
      self.ins_39_elapsed = 0

    if(keys.__contains__("ins_40")):
      Y_inst = self.getInstances(Y, "ins_40")
      self.ins_40_state = self.extTransition_Processor(self.ins_40_state, Y_inst, self.ins_40_elapsed)
      self.ins_40_timeLeft = self.timeAdvance_Processor(self.ins_40_state)
      self.ins_40_elapsed = 0

    if(keys.__contains__("ins_41")):
      Y_inst = self.getInstances(Y, "ins_41")
      self.ins_41_state = self.extTransition_Processor(self.ins_41_state, Y_inst, self.ins_41_elapsed)
      self.ins_41_timeLeft = self.timeAdvance_Processor(self.ins_41_state)
      self.ins_41_elapsed = 0

    if(keys.__contains__("ins_42")):
      Y_inst = self.getInstances(Y, "ins_42")
      self.ins_42_state = self.extTransition_Processor(self.ins_42_state, Y_inst, self.ins_42_elapsed)
      self.ins_42_timeLeft = self.timeAdvance_Processor(self.ins_42_state)
      self.ins_42_elapsed = 0

    if(keys.__contains__("ins_43")):
      Y_inst = self.getInstances(Y, "ins_43")
      self.ins_43_state = self.extTransition_Processor(self.ins_43_state, Y_inst, self.ins_43_elapsed)
      self.ins_43_timeLeft = self.timeAdvance_Processor(self.ins_43_state)
      self.ins_43_elapsed = 0

    if(keys.__contains__("ins_44")):
      Y_inst = self.getInstances(Y, "ins_44")
      self.ins_44_state = self.extTransition_Processor(self.ins_44_state, Y_inst, self.ins_44_elapsed)
      self.ins_44_timeLeft = self.timeAdvance_Processor(self.ins_44_state)
      self.ins_44_elapsed = 0

    if(keys.__contains__("ins_45")):
      Y_inst = self.getInstances(Y, "ins_45")
      self.ins_45_state = self.extTransition_Processor(self.ins_45_state, Y_inst, self.ins_45_elapsed)
      self.ins_45_timeLeft = self.timeAdvance_Processor(self.ins_45_state)
      self.ins_45_elapsed = 0

    if(keys.__contains__("ins_46")):
      Y_inst = self.getInstances(Y, "ins_46")
      self.ins_46_state = self.extTransition_Processor(self.ins_46_state, Y_inst, self.ins_46_elapsed)
      self.ins_46_timeLeft = self.timeAdvance_Processor(self.ins_46_state)
      self.ins_46_elapsed = 0

    if(keys.__contains__("ins_47")):
      Y_inst = self.getInstances(Y, "ins_47")
      self.ins_47_state = self.extTransition_Processor(self.ins_47_state, Y_inst, self.ins_47_elapsed)
      self.ins_47_timeLeft = self.timeAdvance_Processor(self.ins_47_state)
      self.ins_47_elapsed = 0

    if(keys.__contains__("ins_48")):
      Y_inst = self.getInstances(Y, "ins_48")
      self.ins_48_state = self.extTransition_Processor(self.ins_48_state, Y_inst, self.ins_48_elapsed)
      self.ins_48_timeLeft = self.timeAdvance_Processor(self.ins_48_state)
      self.ins_48_elapsed = 0

    if(keys.__contains__("ins_49")):
      Y_inst = self.getInstances(Y, "ins_49")
      self.ins_49_state = self.extTransition_Processor(self.ins_49_state, Y_inst, self.ins_49_elapsed)
      self.ins_49_timeLeft = self.timeAdvance_Processor(self.ins_49_state)
      self.ins_49_elapsed = 0

    if(keys.__contains__("ins_50")):
      Y_inst = self.getInstances(Y, "ins_50")
      self.ins_50_state = self.extTransition_Processor(self.ins_50_state, Y_inst, self.ins_50_elapsed)
      self.ins_50_timeLeft = self.timeAdvance_Processor(self.ins_50_state)
      self.ins_50_elapsed = 0
    return self.state

  
  def timeAdvance( self ):
    self.timeLefts = list()

    self.timeLefts.append(self.ins_0_timeLeft)

    self.timeLefts.append(self.ins_1_timeLeft)

    self.timeLefts.append(self.ins_2_timeLeft)

    self.timeLefts.append(self.ins_3_timeLeft)

    self.timeLefts.append(self.ins_4_timeLeft)

    self.timeLefts.append(self.ins_5_timeLeft)

    self.timeLefts.append(self.ins_6_timeLeft)

    self.timeLefts.append(self.ins_7_timeLeft)

    self.timeLefts.append(self.ins_8_timeLeft)

    self.timeLefts.append(self.ins_9_timeLeft)

    self.timeLefts.append(self.ins_10_timeLeft)

    self.timeLefts.append(self.ins_11_timeLeft)

    self.timeLefts.append(self.ins_12_timeLeft)

    self.timeLefts.append(self.ins_13_timeLeft)

    self.timeLefts.append(self.ins_14_timeLeft)

    self.timeLefts.append(self.ins_15_timeLeft)

    self.timeLefts.append(self.ins_16_timeLeft)

    self.timeLefts.append(self.ins_17_timeLeft)

    self.timeLefts.append(self.ins_18_timeLeft)

    self.timeLefts.append(self.ins_19_timeLeft)

    self.timeLefts.append(self.ins_20_timeLeft)

    self.timeLefts.append(self.ins_21_timeLeft)

    self.timeLefts.append(self.ins_22_timeLeft)

    self.timeLefts.append(self.ins_23_timeLeft)

    self.timeLefts.append(self.ins_24_timeLeft)

    self.timeLefts.append(self.ins_25_timeLeft)

    self.timeLefts.append(self.ins_26_timeLeft)

    self.timeLefts.append(self.ins_27_timeLeft)

    self.timeLefts.append(self.ins_28_timeLeft)

    self.timeLefts.append(self.ins_29_timeLeft)

    self.timeLefts.append(self.ins_30_timeLeft)

    self.timeLefts.append(self.ins_31_timeLeft)

    self.timeLefts.append(self.ins_32_timeLeft)

    self.timeLefts.append(self.ins_33_timeLeft)

    self.timeLefts.append(self.ins_34_timeLeft)

    self.timeLefts.append(self.ins_35_timeLeft)

    self.timeLefts.append(self.ins_36_timeLeft)

    self.timeLefts.append(self.ins_37_timeLeft)

    self.timeLefts.append(self.ins_38_timeLeft)

    self.timeLefts.append(self.ins_39_timeLeft)

    self.timeLefts.append(self.ins_40_timeLeft)

    self.timeLefts.append(self.ins_41_timeLeft)

    self.timeLefts.append(self.ins_42_timeLeft)

    self.timeLefts.append(self.ins_43_timeLeft)

    self.timeLefts.append(self.ins_44_timeLeft)

    self.timeLefts.append(self.ins_45_timeLeft)

    self.timeLefts.append(self.ins_46_timeLeft)

    self.timeLefts.append(self.ins_47_timeLeft)

    self.timeLefts.append(self.ins_48_timeLeft)

    self.timeLefts.append(self.ins_49_timeLeft)

    self.timeLefts.append(self.ins_50_timeLeft)

    timeSpan = min(self.timeLefts)

    timeSpan = max(0, timeSpan)
    return timeSpan

  
  def outputFnc( self ):
    outp = dict()
    dStar = None
    dStar = self.get_dstar()

    if(dStar == self.ins_0_state):
      outp = self.outputFnc_Generator(self.ins_0_state)
      outp = self.renamePorts(outp, "ins_0")

    if(dStar == self.ins_1_state):
      outp = self.outputFnc_Processor(self.ins_1_state)
      outp = self.renamePorts(outp, "ins_1")

    if(dStar == self.ins_2_state):
      outp = self.outputFnc_Processor(self.ins_2_state)
      outp = self.renamePorts(outp, "ins_2")

    if(dStar == self.ins_3_state):
      outp = self.outputFnc_Processor(self.ins_3_state)
      outp = self.renamePorts(outp, "ins_3")

    if(dStar == self.ins_4_state):
      outp = self.outputFnc_Processor(self.ins_4_state)
      outp = self.renamePorts(outp, "ins_4")

    if(dStar == self.ins_5_state):
      outp = self.outputFnc_Processor(self.ins_5_state)
      outp = self.renamePorts(outp, "ins_5")

    if(dStar == self.ins_6_state):
      outp = self.outputFnc_Processor(self.ins_6_state)
      outp = self.renamePorts(outp, "ins_6")

    if(dStar == self.ins_7_state):
      outp = self.outputFnc_Processor(self.ins_7_state)
      outp = self.renamePorts(outp, "ins_7")

    if(dStar == self.ins_8_state):
      outp = self.outputFnc_Processor(self.ins_8_state)
      outp = self.renamePorts(outp, "ins_8")

    if(dStar == self.ins_9_state):
      outp = self.outputFnc_Processor(self.ins_9_state)
      outp = self.renamePorts(outp, "ins_9")

    if(dStar == self.ins_10_state):
      outp = self.outputFnc_Processor(self.ins_10_state)
      outp = self.renamePorts(outp, "ins_10")

    if(dStar == self.ins_11_state):
      outp = self.outputFnc_Processor(self.ins_11_state)
      outp = self.renamePorts(outp, "ins_11")

    if(dStar == self.ins_12_state):
      outp = self.outputFnc_Processor(self.ins_12_state)
      outp = self.renamePorts(outp, "ins_12")

    if(dStar == self.ins_13_state):
      outp = self.outputFnc_Processor(self.ins_13_state)
      outp = self.renamePorts(outp, "ins_13")

    if(dStar == self.ins_14_state):
      outp = self.outputFnc_Processor(self.ins_14_state)
      outp = self.renamePorts(outp, "ins_14")

    if(dStar == self.ins_15_state):
      outp = self.outputFnc_Processor(self.ins_15_state)
      outp = self.renamePorts(outp, "ins_15")

    if(dStar == self.ins_16_state):
      outp = self.outputFnc_Processor(self.ins_16_state)
      outp = self.renamePorts(outp, "ins_16")

    if(dStar == self.ins_17_state):
      outp = self.outputFnc_Processor(self.ins_17_state)
      outp = self.renamePorts(outp, "ins_17")

    if(dStar == self.ins_18_state):
      outp = self.outputFnc_Processor(self.ins_18_state)
      outp = self.renamePorts(outp, "ins_18")

    if(dStar == self.ins_19_state):
      outp = self.outputFnc_Processor(self.ins_19_state)
      outp = self.renamePorts(outp, "ins_19")

    if(dStar == self.ins_20_state):
      outp = self.outputFnc_Processor(self.ins_20_state)
      outp = self.renamePorts(outp, "ins_20")

    if(dStar == self.ins_21_state):
      outp = self.outputFnc_Processor(self.ins_21_state)
      outp = self.renamePorts(outp, "ins_21")

    if(dStar == self.ins_22_state):
      outp = self.outputFnc_Processor(self.ins_22_state)
      outp = self.renamePorts(outp, "ins_22")

    if(dStar == self.ins_23_state):
      outp = self.outputFnc_Processor(self.ins_23_state)
      outp = self.renamePorts(outp, "ins_23")

    if(dStar == self.ins_24_state):
      outp = self.outputFnc_Processor(self.ins_24_state)
      outp = self.renamePorts(outp, "ins_24")

    if(dStar == self.ins_25_state):
      outp = self.outputFnc_Processor(self.ins_25_state)
      outp = self.renamePorts(outp, "ins_25")

    if(dStar == self.ins_26_state):
      outp = self.outputFnc_Processor(self.ins_26_state)
      outp = self.renamePorts(outp, "ins_26")

    if(dStar == self.ins_27_state):
      outp = self.outputFnc_Processor(self.ins_27_state)
      outp = self.renamePorts(outp, "ins_27")

    if(dStar == self.ins_28_state):
      outp = self.outputFnc_Processor(self.ins_28_state)
      outp = self.renamePorts(outp, "ins_28")

    if(dStar == self.ins_29_state):
      outp = self.outputFnc_Processor(self.ins_29_state)
      outp = self.renamePorts(outp, "ins_29")

    if(dStar == self.ins_30_state):
      outp = self.outputFnc_Processor(self.ins_30_state)
      outp = self.renamePorts(outp, "ins_30")

    if(dStar == self.ins_31_state):
      outp = self.outputFnc_Processor(self.ins_31_state)
      outp = self.renamePorts(outp, "ins_31")

    if(dStar == self.ins_32_state):
      outp = self.outputFnc_Processor(self.ins_32_state)
      outp = self.renamePorts(outp, "ins_32")

    if(dStar == self.ins_33_state):
      outp = self.outputFnc_Processor(self.ins_33_state)
      outp = self.renamePorts(outp, "ins_33")

    if(dStar == self.ins_34_state):
      outp = self.outputFnc_Processor(self.ins_34_state)
      outp = self.renamePorts(outp, "ins_34")

    if(dStar == self.ins_35_state):
      outp = self.outputFnc_Processor(self.ins_35_state)
      outp = self.renamePorts(outp, "ins_35")

    if(dStar == self.ins_36_state):
      outp = self.outputFnc_Processor(self.ins_36_state)
      outp = self.renamePorts(outp, "ins_36")

    if(dStar == self.ins_37_state):
      outp = self.outputFnc_Processor(self.ins_37_state)
      outp = self.renamePorts(outp, "ins_37")

    if(dStar == self.ins_38_state):
      outp = self.outputFnc_Processor(self.ins_38_state)
      outp = self.renamePorts(outp, "ins_38")

    if(dStar == self.ins_39_state):
      outp = self.outputFnc_Processor(self.ins_39_state)
      outp = self.renamePorts(outp, "ins_39")

    if(dStar == self.ins_40_state):
      outp = self.outputFnc_Processor(self.ins_40_state)
      outp = self.renamePorts(outp, "ins_40")

    if(dStar == self.ins_41_state):
      outp = self.outputFnc_Processor(self.ins_41_state)
      outp = self.renamePorts(outp, "ins_41")

    if(dStar == self.ins_42_state):
      outp = self.outputFnc_Processor(self.ins_42_state)
      outp = self.renamePorts(outp, "ins_42")

    if(dStar == self.ins_43_state):
      outp = self.outputFnc_Processor(self.ins_43_state)
      outp = self.renamePorts(outp, "ins_43")

    if(dStar == self.ins_44_state):
      outp = self.outputFnc_Processor(self.ins_44_state)
      outp = self.renamePorts(outp, "ins_44")

    if(dStar == self.ins_45_state):
      outp = self.outputFnc_Processor(self.ins_45_state)
      outp = self.renamePorts(outp, "ins_45")

    if(dStar == self.ins_46_state):
      outp = self.outputFnc_Processor(self.ins_46_state)
      outp = self.renamePorts(outp, "ins_46")

    if(dStar == self.ins_47_state):
      outp = self.outputFnc_Processor(self.ins_47_state)
      outp = self.renamePorts(outp, "ins_47")

    if(dStar == self.ins_48_state):
      outp = self.outputFnc_Processor(self.ins_48_state)
      outp = self.renamePorts(outp, "ins_48")

    if(dStar == self.ins_49_state):
      outp = self.outputFnc_Processor(self.ins_49_state)
      outp = self.renamePorts(outp, "ins_49")

    if(dStar == self.ins_50_state):
      outp = self.outputFnc_Processor(self.ins_50_state)
      outp = self.renamePorts(outp, "ins_50")

    outp = self.mapConnections(outp)

    self.poke(self.p_out, outp.get("p_out", None))


  
  def mapConnections( self, X ):
    Y = dict()

    if(X.__contains__("ins_0_p_out")):
      Y["ins_1_p_in"] = X["ins_0_p_out"]

    if(X.__contains__("ins_1_p_out")):
      Y["ins_2_p_in"] = X["ins_1_p_out"]

    if(X.__contains__("ins_2_p_out")):
      Y["ins_3_p_in"] = X["ins_2_p_out"]

    if(X.__contains__("ins_3_p_out")):
      Y["ins_4_p_in"] = X["ins_3_p_out"]

    if(X.__contains__("ins_4_p_out")):
      Y["ins_5_p_in"] = X["ins_4_p_out"]

    if(X.__contains__("ins_5_p_out")):
      Y["ins_6_p_in"] = X["ins_5_p_out"]

    if(X.__contains__("ins_6_p_out")):
      Y["ins_7_p_in"] = X["ins_6_p_out"]

    if(X.__contains__("ins_7_p_out")):
      Y["ins_8_p_in"] = X["ins_7_p_out"]

    if(X.__contains__("ins_8_p_out")):
      Y["ins_9_p_in"] = X["ins_8_p_out"]

    if(X.__contains__("ins_9_p_out")):
      Y["ins_10_p_in"] = X["ins_9_p_out"]

    if(X.__contains__("ins_10_p_out")):
      Y["ins_11_p_in"] = X["ins_10_p_out"]

    if(X.__contains__("ins_11_p_out")):
      Y["ins_12_p_in"] = X["ins_11_p_out"]

    if(X.__contains__("ins_12_p_out")):
      Y["ins_13_p_in"] = X["ins_12_p_out"]

    if(X.__contains__("ins_13_p_out")):
      Y["ins_14_p_in"] = X["ins_13_p_out"]

    if(X.__contains__("ins_14_p_out")):
      Y["ins_15_p_in"] = X["ins_14_p_out"]

    if(X.__contains__("ins_15_p_out")):
      Y["ins_16_p_in"] = X["ins_15_p_out"]

    if(X.__contains__("ins_16_p_out")):
      Y["ins_17_p_in"] = X["ins_16_p_out"]

    if(X.__contains__("ins_17_p_out")):
      Y["ins_18_p_in"] = X["ins_17_p_out"]

    if(X.__contains__("ins_18_p_out")):
      Y["ins_19_p_in"] = X["ins_18_p_out"]

    if(X.__contains__("ins_19_p_out")):
      Y["ins_20_p_in"] = X["ins_19_p_out"]

    if(X.__contains__("ins_20_p_out")):
      Y["ins_21_p_in"] = X["ins_20_p_out"]

    if(X.__contains__("ins_21_p_out")):
      Y["ins_22_p_in"] = X["ins_21_p_out"]

    if(X.__contains__("ins_22_p_out")):
      Y["ins_23_p_in"] = X["ins_22_p_out"]

    if(X.__contains__("ins_23_p_out")):
      Y["ins_24_p_in"] = X["ins_23_p_out"]

    if(X.__contains__("ins_24_p_out")):
      Y["ins_25_p_in"] = X["ins_24_p_out"]

    if(X.__contains__("ins_25_p_out")):
      Y["ins_26_p_in"] = X["ins_25_p_out"]

    if(X.__contains__("ins_26_p_out")):
      Y["ins_27_p_in"] = X["ins_26_p_out"]

    if(X.__contains__("ins_27_p_out")):
      Y["ins_28_p_in"] = X["ins_27_p_out"]

    if(X.__contains__("ins_28_p_out")):
      Y["ins_29_p_in"] = X["ins_28_p_out"]

    if(X.__contains__("ins_29_p_out")):
      Y["ins_30_p_in"] = X["ins_29_p_out"]

    if(X.__contains__("ins_30_p_out")):
      Y["ins_31_p_in"] = X["ins_30_p_out"]

    if(X.__contains__("ins_31_p_out")):
      Y["ins_32_p_in"] = X["ins_31_p_out"]

    if(X.__contains__("ins_32_p_out")):
      Y["ins_33_p_in"] = X["ins_32_p_out"]

    if(X.__contains__("ins_33_p_out")):
      Y["ins_34_p_in"] = X["ins_33_p_out"]

    if(X.__contains__("ins_34_p_out")):
      Y["ins_35_p_in"] = X["ins_34_p_out"]

    if(X.__contains__("ins_35_p_out")):
      Y["ins_36_p_in"] = X["ins_35_p_out"]

    if(X.__contains__("ins_36_p_out")):
      Y["ins_37_p_in"] = X["ins_36_p_out"]

    if(X.__contains__("ins_37_p_out")):
      Y["ins_38_p_in"] = X["ins_37_p_out"]

    if(X.__contains__("ins_38_p_out")):
      Y["ins_39_p_in"] = X["ins_38_p_out"]

    if(X.__contains__("ins_39_p_out")):
      Y["ins_40_p_in"] = X["ins_39_p_out"]

    if(X.__contains__("ins_40_p_out")):
      Y["ins_41_p_in"] = X["ins_40_p_out"]

    if(X.__contains__("ins_41_p_out")):
      Y["ins_42_p_in"] = X["ins_41_p_out"]

    if(X.__contains__("ins_42_p_out")):
      Y["ins_43_p_in"] = X["ins_42_p_out"]

    if(X.__contains__("ins_43_p_out")):
      Y["ins_44_p_in"] = X["ins_43_p_out"]

    if(X.__contains__("ins_44_p_out")):
      Y["ins_45_p_in"] = X["ins_44_p_out"]

    if(X.__contains__("ins_45_p_out")):
      Y["ins_46_p_in"] = X["ins_45_p_out"]

    if(X.__contains__("ins_46_p_out")):
      Y["ins_47_p_in"] = X["ins_46_p_out"]

    if(X.__contains__("ins_47_p_out")):
      Y["ins_48_p_in"] = X["ins_47_p_out"]

    if(X.__contains__("ins_48_p_out")):
      Y["ins_49_p_in"] = X["ins_48_p_out"]

    if(X.__contains__("ins_49_p_out")):
      Y["ins_50_p_in"] = X["ins_49_p_out"]

    if(X.__contains__("ins_50_p_out")):
      Y["p_out"] = X["ins_50_p_out"]
    return Y

  
  def getModelKeys( self, X ):
    keys = None
    counter = 0
    key = ""
    new_key = ""
    searchname = ""
    length = 0
    Y = list()

    keys = X.keys()

    counter = 0

    length = keys.__len__()

    while counter < length:
      key = keys[counter]
      if(key.__contains__("ins_0")):
        Y.append("ins_0")
      if(key.__contains__("ins_1")):
        Y.append("ins_1")
      if(key.__contains__("ins_2")):
        Y.append("ins_2")
      if(key.__contains__("ins_3")):
        Y.append("ins_3")
      if(key.__contains__("ins_4")):
        Y.append("ins_4")
      if(key.__contains__("ins_5")):
        Y.append("ins_5")
      if(key.__contains__("ins_6")):
        Y.append("ins_6")
      if(key.__contains__("ins_7")):
        Y.append("ins_7")
      if(key.__contains__("ins_8")):
        Y.append("ins_8")
      if(key.__contains__("ins_9")):
        Y.append("ins_9")
      if(key.__contains__("ins_10")):
        Y.append("ins_10")
      if(key.__contains__("ins_11")):
        Y.append("ins_11")
      if(key.__contains__("ins_12")):
        Y.append("ins_12")
      if(key.__contains__("ins_13")):
        Y.append("ins_13")
      if(key.__contains__("ins_14")):
        Y.append("ins_14")
      if(key.__contains__("ins_15")):
        Y.append("ins_15")
      if(key.__contains__("ins_16")):
        Y.append("ins_16")
      if(key.__contains__("ins_17")):
        Y.append("ins_17")
      if(key.__contains__("ins_18")):
        Y.append("ins_18")
      if(key.__contains__("ins_19")):
        Y.append("ins_19")
      if(key.__contains__("ins_20")):
        Y.append("ins_20")
      if(key.__contains__("ins_21")):
        Y.append("ins_21")
      if(key.__contains__("ins_22")):
        Y.append("ins_22")
      if(key.__contains__("ins_23")):
        Y.append("ins_23")
      if(key.__contains__("ins_24")):
        Y.append("ins_24")
      if(key.__contains__("ins_25")):
        Y.append("ins_25")
      if(key.__contains__("ins_26")):
        Y.append("ins_26")
      if(key.__contains__("ins_27")):
        Y.append("ins_27")
      if(key.__contains__("ins_28")):
        Y.append("ins_28")
      if(key.__contains__("ins_29")):
        Y.append("ins_29")
      if(key.__contains__("ins_30")):
        Y.append("ins_30")
      if(key.__contains__("ins_31")):
        Y.append("ins_31")
      if(key.__contains__("ins_32")):
        Y.append("ins_32")
      if(key.__contains__("ins_33")):
        Y.append("ins_33")
      if(key.__contains__("ins_34")):
        Y.append("ins_34")
      if(key.__contains__("ins_35")):
        Y.append("ins_35")
      if(key.__contains__("ins_36")):
        Y.append("ins_36")
      if(key.__contains__("ins_37")):
        Y.append("ins_37")
      if(key.__contains__("ins_38")):
        Y.append("ins_38")
      if(key.__contains__("ins_39")):
        Y.append("ins_39")
      if(key.__contains__("ins_40")):
        Y.append("ins_40")
      if(key.__contains__("ins_41")):
        Y.append("ins_41")
      if(key.__contains__("ins_42")):
        Y.append("ins_42")
      if(key.__contains__("ins_43")):
        Y.append("ins_43")
      if(key.__contains__("ins_44")):
        Y.append("ins_44")
      if(key.__contains__("ins_45")):
        Y.append("ins_45")
      if(key.__contains__("ins_46")):
        Y.append("ins_46")
      if(key.__contains__("ins_47")):
        Y.append("ins_47")
      if(key.__contains__("ins_48")):
        Y.append("ins_48")
      if(key.__contains__("ins_49")):
        Y.append("ins_49")
      if(key.__contains__("ins_50")):
        Y.append("ins_50")
      counter = counter + 1
    return Y

  
  def getInstances( self, X, name ):
    keys = None
    counter = 0
    key = ""
    new_key = ""
    searchname = ""
    length = 0
    Y = dict()

    keys = X.keys()

    counter = 0

    length = keys.__len__()

    while counter < length:
      key = keys[counter]
      if(key.__contains__(name)):
        searchname = name + "_"
        new_key = key.split(searchname)
        new_key = new_key[1]
        Y[new_key] = X[key]
      counter = counter + 1
    return Y

  
  def renamePorts( self, X, name ):
    Y=dict()
    keys = list()
    newname = ""
    key = ""
    counter = 0
    length = 0
    keys = X.keys()

    counter = 0

    length = keys.__len__()

    while counter < length:
      key = keys[counter]
      newname = name + "_" + key
      Y[newname] = X[key]
      counter = counter + 1
    return Y


  def __str__(self):
    strRep = ''
    strRep = strRep + "\nX: " + str(self.X)
    strRep = strRep + "\ntimeLefts: "
    for item in self.timeLefts:
      strRep = strRep + "\n\t" + str(item)
    strRep = strRep + "\nelapsed: " + str(self.elapsed)
    strRep = strRep + "\nins_0_state: " + str(self.ins_0_state)
    strRep = strRep + "\nins_0_timeLeft: " + str(self.ins_0_timeLeft)
    strRep = strRep + "\nins_0_elapsed: " + str(self.ins_0_elapsed)
    strRep = strRep + "\nins_1_state: " + str(self.ins_1_state)
    strRep = strRep + "\nins_1_timeLeft: " + str(self.ins_1_timeLeft)
    strRep = strRep + "\nins_1_elapsed: " + str(self.ins_1_elapsed)
    strRep = strRep + "\nins_2_state: " + str(self.ins_2_state)
    strRep = strRep + "\nins_2_timeLeft: " + str(self.ins_2_timeLeft)
    strRep = strRep + "\nins_2_elapsed: " + str(self.ins_2_elapsed)
    strRep = strRep + "\nins_3_state: " + str(self.ins_3_state)
    strRep = strRep + "\nins_3_timeLeft: " + str(self.ins_3_timeLeft)
    strRep = strRep + "\nins_3_elapsed: " + str(self.ins_3_elapsed)
    strRep = strRep + "\nins_4_state: " + str(self.ins_4_state)
    strRep = strRep + "\nins_4_timeLeft: " + str(self.ins_4_timeLeft)
    strRep = strRep + "\nins_4_elapsed: " + str(self.ins_4_elapsed)
    strRep = strRep + "\nins_5_state: " + str(self.ins_5_state)
    strRep = strRep + "\nins_5_timeLeft: " + str(self.ins_5_timeLeft)
    strRep = strRep + "\nins_5_elapsed: " + str(self.ins_5_elapsed)
    strRep = strRep + "\nins_6_state: " + str(self.ins_6_state)
    strRep = strRep + "\nins_6_timeLeft: " + str(self.ins_6_timeLeft)
    strRep = strRep + "\nins_6_elapsed: " + str(self.ins_6_elapsed)
    strRep = strRep + "\nins_7_state: " + str(self.ins_7_state)
    strRep = strRep + "\nins_7_timeLeft: " + str(self.ins_7_timeLeft)
    strRep = strRep + "\nins_7_elapsed: " + str(self.ins_7_elapsed)
    strRep = strRep + "\nins_8_state: " + str(self.ins_8_state)
    strRep = strRep + "\nins_8_timeLeft: " + str(self.ins_8_timeLeft)
    strRep = strRep + "\nins_8_elapsed: " + str(self.ins_8_elapsed)
    strRep = strRep + "\nins_9_state: " + str(self.ins_9_state)
    strRep = strRep + "\nins_9_timeLeft: " + str(self.ins_9_timeLeft)
    strRep = strRep + "\nins_9_elapsed: " + str(self.ins_9_elapsed)
    strRep = strRep + "\nins_10_state: " + str(self.ins_10_state)
    strRep = strRep + "\nins_10_timeLeft: " + str(self.ins_10_timeLeft)
    strRep = strRep + "\nins_10_elapsed: " + str(self.ins_10_elapsed)
    strRep = strRep + "\nins_11_state: " + str(self.ins_11_state)
    strRep = strRep + "\nins_11_timeLeft: " + str(self.ins_11_timeLeft)
    strRep = strRep + "\nins_11_elapsed: " + str(self.ins_11_elapsed)
    strRep = strRep + "\nins_12_state: " + str(self.ins_12_state)
    strRep = strRep + "\nins_12_timeLeft: " + str(self.ins_12_timeLeft)
    strRep = strRep + "\nins_12_elapsed: " + str(self.ins_12_elapsed)
    strRep = strRep + "\nins_13_state: " + str(self.ins_13_state)
    strRep = strRep + "\nins_13_timeLeft: " + str(self.ins_13_timeLeft)
    strRep = strRep + "\nins_13_elapsed: " + str(self.ins_13_elapsed)
    strRep = strRep + "\nins_14_state: " + str(self.ins_14_state)
    strRep = strRep + "\nins_14_timeLeft: " + str(self.ins_14_timeLeft)
    strRep = strRep + "\nins_14_elapsed: " + str(self.ins_14_elapsed)
    strRep = strRep + "\nins_15_state: " + str(self.ins_15_state)
    strRep = strRep + "\nins_15_timeLeft: " + str(self.ins_15_timeLeft)
    strRep = strRep + "\nins_15_elapsed: " + str(self.ins_15_elapsed)
    strRep = strRep + "\nins_16_state: " + str(self.ins_16_state)
    strRep = strRep + "\nins_16_timeLeft: " + str(self.ins_16_timeLeft)
    strRep = strRep + "\nins_16_elapsed: " + str(self.ins_16_elapsed)
    strRep = strRep + "\nins_17_state: " + str(self.ins_17_state)
    strRep = strRep + "\nins_17_timeLeft: " + str(self.ins_17_timeLeft)
    strRep = strRep + "\nins_17_elapsed: " + str(self.ins_17_elapsed)
    strRep = strRep + "\nins_18_state: " + str(self.ins_18_state)
    strRep = strRep + "\nins_18_timeLeft: " + str(self.ins_18_timeLeft)
    strRep = strRep + "\nins_18_elapsed: " + str(self.ins_18_elapsed)
    strRep = strRep + "\nins_19_state: " + str(self.ins_19_state)
    strRep = strRep + "\nins_19_timeLeft: " + str(self.ins_19_timeLeft)
    strRep = strRep + "\nins_19_elapsed: " + str(self.ins_19_elapsed)
    strRep = strRep + "\nins_20_state: " + str(self.ins_20_state)
    strRep = strRep + "\nins_20_timeLeft: " + str(self.ins_20_timeLeft)
    strRep = strRep + "\nins_20_elapsed: " + str(self.ins_20_elapsed)
    strRep = strRep + "\nins_21_state: " + str(self.ins_21_state)
    strRep = strRep + "\nins_21_timeLeft: " + str(self.ins_21_timeLeft)
    strRep = strRep + "\nins_21_elapsed: " + str(self.ins_21_elapsed)
    strRep = strRep + "\nins_22_state: " + str(self.ins_22_state)
    strRep = strRep + "\nins_22_timeLeft: " + str(self.ins_22_timeLeft)
    strRep = strRep + "\nins_22_elapsed: " + str(self.ins_22_elapsed)
    strRep = strRep + "\nins_23_state: " + str(self.ins_23_state)
    strRep = strRep + "\nins_23_timeLeft: " + str(self.ins_23_timeLeft)
    strRep = strRep + "\nins_23_elapsed: " + str(self.ins_23_elapsed)
    strRep = strRep + "\nins_24_state: " + str(self.ins_24_state)
    strRep = strRep + "\nins_24_timeLeft: " + str(self.ins_24_timeLeft)
    strRep = strRep + "\nins_24_elapsed: " + str(self.ins_24_elapsed)
    strRep = strRep + "\nins_25_state: " + str(self.ins_25_state)
    strRep = strRep + "\nins_25_timeLeft: " + str(self.ins_25_timeLeft)
    strRep = strRep + "\nins_25_elapsed: " + str(self.ins_25_elapsed)
    strRep = strRep + "\nins_26_state: " + str(self.ins_26_state)
    strRep = strRep + "\nins_26_timeLeft: " + str(self.ins_26_timeLeft)
    strRep = strRep + "\nins_26_elapsed: " + str(self.ins_26_elapsed)
    strRep = strRep + "\nins_27_state: " + str(self.ins_27_state)
    strRep = strRep + "\nins_27_timeLeft: " + str(self.ins_27_timeLeft)
    strRep = strRep + "\nins_27_elapsed: " + str(self.ins_27_elapsed)
    strRep = strRep + "\nins_28_state: " + str(self.ins_28_state)
    strRep = strRep + "\nins_28_timeLeft: " + str(self.ins_28_timeLeft)
    strRep = strRep + "\nins_28_elapsed: " + str(self.ins_28_elapsed)
    strRep = strRep + "\nins_29_state: " + str(self.ins_29_state)
    strRep = strRep + "\nins_29_timeLeft: " + str(self.ins_29_timeLeft)
    strRep = strRep + "\nins_29_elapsed: " + str(self.ins_29_elapsed)
    strRep = strRep + "\nins_30_state: " + str(self.ins_30_state)
    strRep = strRep + "\nins_30_timeLeft: " + str(self.ins_30_timeLeft)
    strRep = strRep + "\nins_30_elapsed: " + str(self.ins_30_elapsed)
    strRep = strRep + "\nins_31_state: " + str(self.ins_31_state)
    strRep = strRep + "\nins_31_timeLeft: " + str(self.ins_31_timeLeft)
    strRep = strRep + "\nins_31_elapsed: " + str(self.ins_31_elapsed)
    strRep = strRep + "\nins_32_state: " + str(self.ins_32_state)
    strRep = strRep + "\nins_32_timeLeft: " + str(self.ins_32_timeLeft)
    strRep = strRep + "\nins_32_elapsed: " + str(self.ins_32_elapsed)
    strRep = strRep + "\nins_33_state: " + str(self.ins_33_state)
    strRep = strRep + "\nins_33_timeLeft: " + str(self.ins_33_timeLeft)
    strRep = strRep + "\nins_33_elapsed: " + str(self.ins_33_elapsed)
    strRep = strRep + "\nins_34_state: " + str(self.ins_34_state)
    strRep = strRep + "\nins_34_timeLeft: " + str(self.ins_34_timeLeft)
    strRep = strRep + "\nins_34_elapsed: " + str(self.ins_34_elapsed)
    strRep = strRep + "\nins_35_state: " + str(self.ins_35_state)
    strRep = strRep + "\nins_35_timeLeft: " + str(self.ins_35_timeLeft)
    strRep = strRep + "\nins_35_elapsed: " + str(self.ins_35_elapsed)
    strRep = strRep + "\nins_36_state: " + str(self.ins_36_state)
    strRep = strRep + "\nins_36_timeLeft: " + str(self.ins_36_timeLeft)
    strRep = strRep + "\nins_36_elapsed: " + str(self.ins_36_elapsed)
    strRep = strRep + "\nins_37_state: " + str(self.ins_37_state)
    strRep = strRep + "\nins_37_timeLeft: " + str(self.ins_37_timeLeft)
    strRep = strRep + "\nins_37_elapsed: " + str(self.ins_37_elapsed)
    strRep = strRep + "\nins_38_state: " + str(self.ins_38_state)
    strRep = strRep + "\nins_38_timeLeft: " + str(self.ins_38_timeLeft)
    strRep = strRep + "\nins_38_elapsed: " + str(self.ins_38_elapsed)
    strRep = strRep + "\nins_39_state: " + str(self.ins_39_state)
    strRep = strRep + "\nins_39_timeLeft: " + str(self.ins_39_timeLeft)
    strRep = strRep + "\nins_39_elapsed: " + str(self.ins_39_elapsed)
    strRep = strRep + "\nins_40_state: " + str(self.ins_40_state)
    strRep = strRep + "\nins_40_timeLeft: " + str(self.ins_40_timeLeft)
    strRep = strRep + "\nins_40_elapsed: " + str(self.ins_40_elapsed)
    strRep = strRep + "\nins_41_state: " + str(self.ins_41_state)
    strRep = strRep + "\nins_41_timeLeft: " + str(self.ins_41_timeLeft)
    strRep = strRep + "\nins_41_elapsed: " + str(self.ins_41_elapsed)
    strRep = strRep + "\nins_42_state: " + str(self.ins_42_state)
    strRep = strRep + "\nins_42_timeLeft: " + str(self.ins_42_timeLeft)
    strRep = strRep + "\nins_42_elapsed: " + str(self.ins_42_elapsed)
    strRep = strRep + "\nins_43_state: " + str(self.ins_43_state)
    strRep = strRep + "\nins_43_timeLeft: " + str(self.ins_43_timeLeft)
    strRep = strRep + "\nins_43_elapsed: " + str(self.ins_43_elapsed)
    strRep = strRep + "\nins_44_state: " + str(self.ins_44_state)
    strRep = strRep + "\nins_44_timeLeft: " + str(self.ins_44_timeLeft)
    strRep = strRep + "\nins_44_elapsed: " + str(self.ins_44_elapsed)
    strRep = strRep + "\nins_45_state: " + str(self.ins_45_state)
    strRep = strRep + "\nins_45_timeLeft: " + str(self.ins_45_timeLeft)
    strRep = strRep + "\nins_45_elapsed: " + str(self.ins_45_elapsed)
    strRep = strRep + "\nins_46_state: " + str(self.ins_46_state)
    strRep = strRep + "\nins_46_timeLeft: " + str(self.ins_46_timeLeft)
    strRep = strRep + "\nins_46_elapsed: " + str(self.ins_46_elapsed)
    strRep = strRep + "\nins_47_state: " + str(self.ins_47_state)
    strRep = strRep + "\nins_47_timeLeft: " + str(self.ins_47_timeLeft)
    strRep = strRep + "\nins_47_elapsed: " + str(self.ins_47_elapsed)
    strRep = strRep + "\nins_48_state: " + str(self.ins_48_state)
    strRep = strRep + "\nins_48_timeLeft: " + str(self.ins_48_timeLeft)
    strRep = strRep + "\nins_48_elapsed: " + str(self.ins_48_elapsed)
    strRep = strRep + "\nins_49_state: " + str(self.ins_49_state)
    strRep = strRep + "\nins_49_timeLeft: " + str(self.ins_49_timeLeft)
    strRep = strRep + "\nins_49_elapsed: " + str(self.ins_49_elapsed)
    strRep = strRep + "\nins_50_state: " + str(self.ins_50_state)
    strRep = strRep + "\nins_50_timeLeft: " + str(self.ins_50_timeLeft)
    strRep = strRep + "\nins_50_elapsed: " + str(self.ins_50_elapsed)
    return strRep

  def toXML(self):
    strRep = ''
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>X</name>"
    strRep = strRep + "\n\t<type>dict</type>"
    if(self.X!=None):
      strRep = strRep + "\n\t<value>"+self.X.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>timeLefts</name>"
    strRep = strRep + "\n\t<type>list</type>"
    strRep = strRep + "\n\t<value>"
    for item in self.timeLefts:
      strRep = strRep + "\n\t" + item.toXML()
    strRep = strRep + "\n\t</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_0_state</name>"
    strRep = strRep + "\n\t<type>GeneratorState</type>"
    if(self.ins_0_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_0_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_0_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_0_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_0_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_0_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_1_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_1_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_1_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_1_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_1_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_1_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_1_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_2_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_2_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_2_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_2_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_2_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_2_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_2_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_3_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_3_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_3_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_3_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_3_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_3_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_3_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_4_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_4_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_4_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_4_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_4_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_4_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_4_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_5_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_5_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_5_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_5_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_5_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_5_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_5_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_6_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_6_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_6_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_6_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_6_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_6_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_6_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_7_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_7_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_7_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_7_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_7_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_7_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_7_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_8_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_8_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_8_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_8_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_8_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_8_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_8_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_9_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_9_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_9_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_9_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_9_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_9_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_9_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_10_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_10_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_10_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_10_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_10_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_10_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_10_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_11_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_11_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_11_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_11_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_11_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_11_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_11_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_12_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_12_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_12_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_12_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_12_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_12_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_12_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_13_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_13_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_13_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_13_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_13_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_13_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_13_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_14_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_14_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_14_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_14_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_14_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_14_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_14_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_15_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_15_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_15_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_15_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_15_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_15_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_15_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_16_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_16_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_16_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_16_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_16_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_16_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_16_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_17_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_17_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_17_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_17_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_17_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_17_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_17_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_18_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_18_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_18_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_18_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_18_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_18_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_18_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_19_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_19_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_19_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_19_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_19_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_19_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_19_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_20_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_20_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_20_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_20_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_20_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_20_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_20_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_21_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_21_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_21_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_21_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_21_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_21_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_21_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_22_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_22_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_22_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_22_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_22_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_22_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_22_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_23_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_23_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_23_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_23_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_23_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_23_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_23_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_24_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_24_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_24_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_24_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_24_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_24_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_24_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_25_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_25_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_25_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_25_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_25_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_25_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_25_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_26_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_26_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_26_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_26_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_26_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_26_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_26_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_27_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_27_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_27_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_27_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_27_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_27_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_27_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_28_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_28_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_28_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_28_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_28_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_28_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_28_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_29_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_29_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_29_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_29_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_29_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_29_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_29_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_30_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_30_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_30_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_30_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_30_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_30_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_30_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_31_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_31_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_31_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_31_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_31_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_31_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_31_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_32_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_32_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_32_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_32_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_32_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_32_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_32_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_33_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_33_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_33_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_33_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_33_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_33_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_33_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_34_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_34_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_34_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_34_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_34_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_34_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_34_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_35_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_35_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_35_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_35_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_35_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_35_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_35_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_36_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_36_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_36_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_36_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_36_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_36_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_36_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_37_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_37_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_37_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_37_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_37_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_37_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_37_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_38_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_38_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_38_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_38_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_38_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_38_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_38_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_39_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_39_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_39_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_39_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_39_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_39_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_39_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_40_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_40_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_40_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_40_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_40_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_40_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_40_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_41_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_41_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_41_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_41_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_41_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_41_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_41_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_42_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_42_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_42_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_42_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_42_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_42_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_42_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_43_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_43_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_43_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_43_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_43_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_43_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_43_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_44_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_44_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_44_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_44_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_44_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_44_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_44_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_45_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_45_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_45_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_45_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_45_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_45_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_45_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_46_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_46_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_46_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_46_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_46_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_46_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_46_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_47_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_47_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_47_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_47_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_47_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_47_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_47_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_48_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_48_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_48_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_48_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_48_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_48_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_48_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_49_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_49_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_49_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_49_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_49_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_49_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_49_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"C\">"
    strRep = strRep + "\n\t<name>ins_50_state</name>"
    strRep = strRep + "\n\t<type>ProcessorState</type>"
    if(self.ins_50_state!=None):
      strRep = strRep + "\n\t<value>"+self.ins_50_state.toXML()+"</value>"
    else:
      strRep = strRep + "\n\t<value>None</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_50_timeLeft</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_50_timeLeft)+"</value>"
    strRep = strRep + "\n</attribute>"
    strRep = strRep + "\n<attribute category=\"P\">"
    strRep = strRep + "\n\t<name>ins_50_elapsed</name>"
    strRep = strRep + "\n\t<type>Real</type>"
    strRep = strRep + "\n\t<value>"+str(self.ins_50_elapsed)+"</value>"
    strRep = strRep + "\n</attribute>"
    return strRep

class Job( object ):
  def __init__(self, jobSize):
    self.jobSize = jobSize

  def __str__(self):
    strRep = ''
    return strRep

  def toXML(self):
    strRep = ''
    return strRep

class Experiment( object ):
  def __init__(self):
    self.rootModel = Root()
    self.sim = Simulator(model = self.rootModel)
    self.verbose = False
    self.trace = False
    self.end_time = 1000
  def simulate(self):
    self.sim.simulate(termination_condition=terminate_at(self.end_time), verbose=self.verbose)




def terminate_at(t):
 def f(model, clock):
  if clock >= t:
    return True
  else:
    return False
 return f
if __name__ == '__main__':
  experiment = Experiment()
  experiment.simulate()