time_init=input("Please enter initial time: ");
time_end=input("Please enter end time: ");
time_step=input("Please enter time step: ");
num_of_intervals=(time_end - time_init)/time_step;
time = linspace(time_init, time_end, num_of_intervals)';
# Constants 
global AC_PI_last=3.14159265
# Parameters 
global R1_r_last=10
global R2_r_last=10
global C_c_last=1
global AC_VA_last=220
global AC_f_last=50
global C_v=zeros(num_of_intervals, 1);
global C_v_last=C_v(1);
global der_C_v=zeros(num_of_intervals, 1);
der_C_v_last=der_C_v(1);
global C_i=zeros(num_of_intervals, 1);
global C_i_last=C_i(1);
global AC_i=zeros(num_of_intervals, 1);
global AC_i_last=AC_i(1);
global G_p_i=zeros(num_of_intervals, 1);
global G_p_i_last=G_p_i(1);
global C_n_i=zeros(num_of_intervals, 1);
global C_n_i_last=C_n_i(1);
global C_p_i=zeros(num_of_intervals, 1);
global C_p_i_last=C_p_i(1);
global R2_n_i=zeros(num_of_intervals, 1);
global R2_n_i_last=R2_n_i(1);
global AC_n_i=zeros(num_of_intervals, 1);
global AC_n_i_last=AC_n_i(1);
global AC_p_i=zeros(num_of_intervals, 1);
global AC_p_i_last=AC_p_i(1);
global R1_n_i=zeros(num_of_intervals, 1);
global R1_n_i_last=R1_n_i(1);
global R1_p_i=zeros(num_of_intervals, 1);
global R1_p_i_last=R1_p_i(1);
global R1_i=zeros(num_of_intervals, 1);
global R1_i_last=R1_i(1);
global R1_v=zeros(num_of_intervals, 1);
global R1_v_last=R1_v(1);
global R1_n_v=zeros(num_of_intervals, 1);
global R1_n_v_last=R1_n_v(1);
global R2_p_v=zeros(num_of_intervals, 1);
global R2_p_v_last=R2_p_v(1);
global R2_v=zeros(num_of_intervals, 1);
global R2_v_last=R2_v(1);
global R2_i=zeros(num_of_intervals, 1);
global R2_i_last=R2_i(1);
global R2_p_i=zeros(num_of_intervals, 1);
global R2_p_i_last=R2_p_i(1);
global R2_n_v=zeros(num_of_intervals, 1);
global R2_n_v_last=R2_n_v(1);
global C_p_v=zeros(num_of_intervals, 1);
global C_p_v_last=C_p_v(1);
global C_n_v=zeros(num_of_intervals, 1);
global C_n_v_last=C_n_v(1);
global R1_p_v=zeros(num_of_intervals, 1);
global R1_p_v_last=R1_p_v(1);
global AC_p_v=zeros(num_of_intervals, 1);
global AC_p_v_last=AC_p_v(1);
global AC_v=zeros(num_of_intervals, 1);
global AC_v_last=AC_v(1);
global AC_n_v=zeros(num_of_intervals, 1);
global AC_n_v_last=AC_n_v(1);
global G_p_v=zeros(num_of_intervals, 1);
global G_p_v_last=G_p_v(1);

function C_v_dot = f_C_v(C_vi, ti)
  global C_i_last;
  global C_c_last;
  C_v_dot(1)=(0.0+(-1.0)*C_i_last*(-1.0))*C_c_last^(-1.0);
endfunction

function loop1 = f_loop1(x)
  global R1_r_last;
  global R1_p_v_last;
  global R2_n_v_last;
  global R2_r_last;
  loop1(1)=x(1)+x(9);
  loop1(2)=x(1)*(-1.0)+x(2)*(-1.0);
  loop1(3)=x(3)+x(2)*(-1.0);
  loop1(4)=x(3)*R1_r_last+x(4)*(-1.0);
  loop1(5)=x(5)+R1_p_v_last*(-1.0)+x(4);
  loop1(6)=x(5)+x(6)*(-1.0);
  loop1(7)=R2_n_v_last+x(6)*(-1.0)+x(7);
  loop1(8)=x(8)*R2_r_last+x(7)*(-1.0);
  loop1(9)=x(8)+x(9)*(-1.0);
endfunction

for i=2:num_of_intervals
  # Equation 1
  G_p_v(i)=0.0;
  # Equation 2
  AC_n_v(i)=(0.0+(-1.0)*G_p_v(i))*(-1.0)^(-1.0);
  # Equation 3
  AC_v(i)=0.0+(-1.0)*AC_VA_last*sin(2*AC_PI_last*time(i))*(-1.0);
  # Equation 4
  AC_p_v(i)=(0.0+(-1.0)*AC_n_v(i)+(-1.0)*AC_v(i))*(-1.0)^(-1.0);
  # Equation 5
  R1_p_v(i)=(0.0+(-1.0)*AC_p_v(i))*(-1.0)^(-1.0);
  # Equation 6
  C_n_v(i)=(0.0+(-1.0)*G_p_v(i))*(-1.0)^(-1.0);
  # Equation 7
  C_p_v(i)=(0.0+(-1.0)*C_n_v(i)+(-1.0)*C_v(i))*(-1.0)^(-1.0);
  # Equation 8
  R2_n_v(i)=0.0+(-1.0)*C_p_v(i)*(-1.0);
  # Equation 9
  init_guess=zeros(9, 1);
  [loop1, info]=fsolve("f_loop1", init_guess);
  R1_n_i(i)=loop1(1);
  R1_p_i(i)=loop1(2);
  R1_i(i)=loop1(3);
  R1_v(i)=loop1(4);
  R1_n_v(i)=loop1(5);
  R2_p_v(i)=loop1(6);
  R2_v(i)=loop1(7);
  R2_i(i)=loop1(8);
  R2_p_i(i)=loop1(9);
  # Equation 10
  AC_p_i(i)=0.0+(-1.0)*R1_p_i(i);
  # Equation 11
  AC_n_i(i)=(0.0+(-1.0)*AC_p_i(i)*(-1.0))*(-1.0)^(-1.0);
  # Equation 12
  R2_n_i(i)=(0.0+(-1.0)*R2_p_i(i)*(-1.0))*(-1.0)^(-1.0);
  # Equation 13
  C_p_i(i)=0.0+(-1.0)*R2_n_i(i);
  # Equation 14
  C_n_i(i)=(0.0+(-1.0)*C_p_i(i)*(-1.0))*(-1.0)^(-1.0);
  # Equation 15
  G_p_i(i)=0.0+(-1.0)*AC_n_i(i)+(-1.0)*C_n_i(i);
  # Equation 16
  AC_i(i)=0.0+(-1.0)*AC_p_i(i)*(-1.0);
  # Equation 17
  C_i(i)=0.0+(-1.0)*C_p_i(i)*(-1.0);
  # Equation 18
  der_C_v(i)=(0.0+(-1.0)*C_i(i)*(-1.0))*C_c_last^(-1.0);
  time_i=linspace(time(i-1), time(i), 10)';
  C_vi0=[C_v_last];
  C_v_i=lsode("f_C_v", C_vi0, time_i);
  C_v(i)=C_v_i(10);
  # update latest values  C_v_last=C_v(i);
  der_C_v_last=der_C_v(i);
  C_i_last=C_i(i);
  AC_i_last=AC_i(i);
  G_p_i_last=G_p_i(i);
  C_n_i_last=C_n_i(i);
  C_p_i_last=C_p_i(i);
  R2_n_i_last=R2_n_i(i);
  AC_n_i_last=AC_n_i(i);
  AC_p_i_last=AC_p_i(i);
  R1_n_i_last=R1_n_i(i);
  R1_p_i_last=R1_p_i(i);
  R1_i_last=R1_i(i);
  R1_v_last=R1_v(i);
  R1_n_v_last=R1_n_v(i);
  R2_p_v_last=R2_p_v(i);
  R2_v_last=R2_v(i);
  R2_i_last=R2_i(i);
  R2_p_i_last=R2_p_i(i);
  R2_n_v_last=R2_n_v(i);
  C_p_v_last=C_p_v(i);
  C_n_v_last=C_n_v(i);
  R1_p_v_last=R1_p_v(i);
  AC_p_v_last=AC_p_v(i);
  AC_v_last=AC_v(i);
  AC_n_v_last=AC_n_v(i);
  G_p_v_last=G_p_v(i);
endfor

